-- suite8.11.0.sp8.1-Scripts-SQL.sql last modified on 02/08/2019

-- Instructions - Use search and replace to replace the following.
--   Replace <LOGIN> with the login the application will use to access the database.

---------------- Begin Checks For Auditing Section  ----------------

-- Gather auditing information

if (select name from sysobjects
    where xtype = 'U'
    and name = 'tmp_AuditingUpgrade') = 'tmp_AuditingUpgrade'
begin
    drop table tmp_AuditingUpgrade
    print 'Dropped table.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

create table tmp_AuditingUpgrade
(
    TableName                            varchar(50)    null,
    UpgradeTable                         char(1)        null,
    UpgradeTrigger                       char(1)        null
)
go


insert into tmp_AuditingUpgrade values ('Invoice','F','F')
insert into tmp_AuditingUpgrade values ('Company','F','F')
insert into tmp_AuditingUpgrade values ('Matter','F','F')
insert into tmp_AuditingUpgrade values ('Person','F','F')
go

if (select name from sysobjects
    where xtype = 'U'
    and name = 'Invoice_Audit') = 'Invoice_Audit'
begin
    update tmp_AuditingUpgrade
      set UpgradeTable = 'T'
    where TableName = 'Invoice'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Invoice') = 'Audit_Invoice'
begin
    update tmp_AuditingUpgrade
      set UpgradeTrigger = 'T'
    where TableName = 'Invoice'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'U'
    and name = 'Company_Audit') = 'Company_Audit'
begin
    update tmp_AuditingUpgrade
      set UpgradeTable = 'T'
    where TableName = 'Company'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Company') = 'Audit_Company'
begin
    update tmp_AuditingUpgrade
      set UpgradeTrigger = 'T'
    where TableName = 'Company'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'U'
    and name = 'Matter_Audit') = 'Matter_Audit'
begin
    update tmp_AuditingUpgrade
      set UpgradeTable = 'T'
    where TableName = 'Matter'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Matter') = 'Audit_Matter'
begin
    update tmp_AuditingUpgrade
      set UpgradeTrigger = 'T'
    where TableName = 'Matter'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'U'
    and name = 'Person_Audit') = 'Person_Audit'
begin
    update tmp_AuditingUpgrade
      set UpgradeTable = 'T'
    where TableName = 'Person'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Person') = 'Audit_Person'
begin
    update tmp_AuditingUpgrade
      set UpgradeTrigger = 'T'
    where TableName = 'Person'
end
else
    print 'The command(s) completed successfully.'
    print ''
go

---------------- End Checks For Auditing Section  ----------------

---------------- Begin Structural Section ----------------

---Company 
--drop constraints
alter table AlternateName
    DROP CONSTRAINT FK_ALTERNAT_REF_1426_COMPANY
go

alter table CALURA
    DROP CONSTRAINT FK_CALURA_REF_1180_COMPANY
go

alter table Canada
    DROP CONSTRAINT FK_CANADA_REF_1174_COMPANY
go

alter table Chart
    DROP CONSTRAINT FK_CHART_REF_1519_COMPANY
go

alter table Company_Person
    DROP CONSTRAINT FK_COMPANY__REF_1267_COMPANY
go

alter table DBAName	
    DROP CONSTRAINT FK_DBANAME_REF_1172_COMPANY
go

alter table FormerName
    DROP CONSTRAINT FK_FORMERNA_REF_1173_COMPANY
go

alter table InsurancePolicy
    DROP CONSTRAINT FK_INSURANC_REF_1270_COMPANY
go

alter table Member
    DROP CONSTRAINT FK_MEMBER_REF_1186_COMPANY
go

alter table Ownership
    DROP CONSTRAINT FK_OWNERSHI_REF_1178_COMPANY
go

alter table Registration
    DROP CONSTRAINT FK_REGISTRA_REF_1183_COMPANY
go

alter table Security
    DROP CONSTRAINT FK_SECURITY_REF_1170_COMPANY
go

if (select name from sysobjects
    where xtype = 'U'
    and name = 'tmp_Company') = 'tmp_Company'
begin
    drop table tmp_Company
    print 'Dropped table.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

create table tmp_Company (
    Company_ID           int                  not null,
   AlternateName        varchar(150)         null,
   AdministrationNumber varchar(20)          null,
   InternalNumber       varchar(40)          null,
   FiscalYearEnd        varchar(40)          null,
   TaxYearEnd           varchar(40)          null,
   HasEmployees         char(1)              null default 'F',
   Purpose_ID           int                  null,
   AgreementDate        datetime             null,
   TerminationDate      datetime             null,
   AnnualMeetingMonth   int                  null,
   AnnualMeetingNotes_ID int                  null,
   AnnualMeetingDate    datetime             null,
   DirectorsMin         int                  null,
   DirectorsMax         int                  null,
   DirectorsAuthorized  int                  null,
   DirectorsQuorum      varchar(255)         null,
   BoardClasses         int                  null,
   BooksLocation        varchar(255)         null,
   SealLocation         varchar(255)         null,
   Successor_EID        int                  null,
   Comments_ID          int                  null,
   DirectorsComments_ID int                  null,
   LastMeetingDate      datetime             null,
   CorpStatusDate       datetime             null,
   LLCGovernedBy        int                  null,
   CompanyType_CD       varchar(40)          null,
   AccountCode          varchar(40)          null,
   ChargeBackPct        numeric(10,4)        null,
   ChargeBackBeginDate  datetime             null,
   ChargeBackCode1      varchar(100)         null,
   ChargeBackCode2      varchar(100)         null,
   ChargeBackCode3      varchar(100)         null,
   LineOfBusiness_CD    varchar(40)          null,
   IsInsuranceCompany   char(1)              null default 'F',
   IsBillingEntity      char(1)              null default 'F',
   ExternalEntityNumber varchar(20)          null,
   eInvoicingVendorID   varchar(50)          null,
   LHOrganizationID		varchar(50)			 null,
   ApprovedFirm         char(1)              null default 'F',
   ApprovedDate         datetime             null,
   DismissalDate        datetime             null,
   BillsCustomer        char(1)              null default 'F',
   BillingMethod_CD     varchar(40)          null,
   PaymentMethod_CD     varchar(40)          null,
   GuidelinesReturned   char(1)              null default 'F',
   DateGuidelinesReturned datetime             null,
   FemaleOwnership      char(1)              null default 'F',
   MinorityFirm         char(1)              null default 'F',
   Domicile_CD          varchar(40)          null,
   Region_CD            varchar(40)          null,
   SubType_CD           varchar(40)          null,
   Reject               char(1)              null default 'F',
   BeginDate            datetime             null,
   EndDate              datetime             null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   CompanyType_CAT      int                  null,
   LineOfBusiness_CAT   int                  null,
   BillingMethod_CAT    int                  null,
   PaymentMethod_CAT    int                  null,
   Domicile_CAT         int                  null,
   Region_CAT           int                  null,
   SubType_CAT          int                  null
)
go

insert into tmp_Company
(
 Company_ID,
   AlternateName,
   AdministrationNumber,
   InternalNumber,
   FiscalYearEnd,
   TaxYearEnd,
   HasEmployees,
   Purpose_ID,
   AgreementDate,
   TerminationDate,
   AnnualMeetingMonth,
   AnnualMeetingNotes_ID,
   AnnualMeetingDate,
   DirectorsMin,
   DirectorsMax,
   DirectorsAuthorized,
   DirectorsQuorum,
   BoardClasses,
   BooksLocation,
   SealLocation,
   Successor_EID,
   Comments_ID,
   DirectorsComments_ID,
   LastMeetingDate,
   CorpStatusDate,
   LLCGovernedBy,
   CompanyType_CD,
   AccountCode,
   ChargeBackPct,
   ChargeBackBeginDate,
   ChargeBackCode1,
   ChargeBackCode2,
   ChargeBackCode3,
   LineOfBusiness_CD,
   IsInsuranceCompany,
   IsBillingEntity,
   ExternalEntityNumber,
   eInvoicingVendorID,
   ApprovedFirm,
   ApprovedDate,
   DismissalDate,
   BillsCustomer,
   BillingMethod_CD,
   PaymentMethod_CD,
   GuidelinesReturned,
   DateGuidelinesReturned,
   FemaleOwnership,
   MinorityFirm,
   Domicile_CD,
   Region_CD,
   SubType_CD,
   Reject,
   BeginDate,
   EndDate,
   ChangeBy,
   LastChange,
   CompanyType_CAT,
   LineOfBusiness_CAT,
   BillingMethod_CAT,
   PaymentMethod_CAT,
   Domicile_CAT,
   Region_CAT,
   SubType_CAT
)
select 
 Company_ID,
   AlternateName,
   AdministrationNumber,
   InternalNumber,
   FiscalYearEnd,
   TaxYearEnd,
   HasEmployees,
   Purpose_ID,
   AgreementDate,
   TerminationDate,
   AnnualMeetingMonth,
   AnnualMeetingNotes_ID,
   AnnualMeetingDate,
   DirectorsMin,
   DirectorsMax,
   DirectorsAuthorized,
   DirectorsQuorum,
   BoardClasses,
   BooksLocation,
   SealLocation,
   Successor_EID,
   Comments_ID,
   DirectorsComments_ID,
   LastMeetingDate,
   CorpStatusDate,
   LLCGovernedBy,
   CompanyType_CD,
   AccountCode,
   ChargeBackPct,
   ChargeBackBeginDate,
   ChargeBackCode1,
   ChargeBackCode2,
   ChargeBackCode3,
   LineOfBusiness_CD,
   IsInsuranceCompany,
   IsBillingEntity,
   ExternalEntityNumber,
   eInvoicingVendorID,
   ApprovedFirm,
   ApprovedDate,
   DismissalDate,
   BillsCustomer,
   BillingMethod_CD,
   PaymentMethod_CD,
   GuidelinesReturned,
   DateGuidelinesReturned,
   FemaleOwnership,
   MinorityFirm,
   Domicile_CD,
   Region_CD,
   SubType_CD,
   Reject,
   BeginDate,
   EndDate,
   ChangeBy,
   LastChange,
   CompanyType_CAT,
   LineOfBusiness_CAT,
   BillingMethod_CAT,
   PaymentMethod_CAT,
   Domicile_CAT,
   Region_CAT,
   SubType_CAT from Company
   go
   
   drop table Company
   go
   
   create table Company (
   Company_ID           int                  not null,
   AlternateName        varchar(150)         null,
   AdministrationNumber varchar(20)          null,
   InternalNumber       varchar(40)          null,
   FiscalYearEnd        varchar(40)          null,
   TaxYearEnd           varchar(40)          null,
   HasEmployees         char(1)              null default 'F',
   Purpose_ID           int                  null,
   AgreementDate        datetime             null,
   TerminationDate      datetime             null,
   AnnualMeetingMonth   int                  null,
   AnnualMeetingNotes_ID int                  null,
   AnnualMeetingDate    datetime             null,
   DirectorsMin         int                  null,
   DirectorsMax         int                  null,
   DirectorsAuthorized  int                  null,
   DirectorsQuorum      varchar(255)         null,
   BoardClasses         int                  null,
   BooksLocation        varchar(255)         null,
   SealLocation         varchar(255)         null,
   Successor_EID        int                  null,
   Comments_ID          int                  null,
   DirectorsComments_ID int                  null,
   LastMeetingDate      datetime             null,
   CorpStatusDate       datetime             null,
   LLCGovernedBy        int                  null,
   CompanyType_CD       varchar(40)          null,
   AccountCode          varchar(40)          null,
   ChargeBackPct        numeric(10,4)        null,
   ChargeBackBeginDate  datetime             null,
   ChargeBackCode1      varchar(100)         null,
   ChargeBackCode2      varchar(100)         null,
   ChargeBackCode3      varchar(100)         null,
   LineOfBusiness_CD    varchar(40)          null,
   IsInsuranceCompany   char(1)              null default 'F',
   IsBillingEntity      char(1)              null default 'F',
   ExternalEntityNumber varchar(20)          null,
   eInvoicingVendorID   varchar(50)          null,
   LHOrganizationID		varchar(50)			 null,
   ApprovedFirm         char(1)              null default 'F',
   ApprovedDate         datetime             null,
   DismissalDate        datetime             null,
   BillsCustomer        char(1)              null default 'F',
   BillingMethod_CD     varchar(40)          null,
   PaymentMethod_CD     varchar(40)          null,
   GuidelinesReturned   char(1)              null default 'F',
   DateGuidelinesReturned datetime             null,
   FemaleOwnership      char(1)              null default 'F',
   MinorityFirm         char(1)              null default 'F',
   Domicile_CD          varchar(40)          null,
   Region_CD            varchar(40)          null,
   SubType_CD           varchar(40)          null,
   Reject               char(1)              null default 'F',
   BeginDate            datetime             null,
   EndDate              datetime             null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   CompanyType_CAT      int                  null,
   LineOfBusiness_CAT   int                  null,
   BillingMethod_CAT    int                  null,
   PaymentMethod_CAT    int                  null,
   Domicile_CAT         int                  null,
   Region_CAT           int                  null,
   SubType_CAT          int                  null,
   constraint PK_COMPANY primary key (Company_ID)
)
go

create index IDX_COMP_SUCCESSOR_EID on Company (
Successor_EID ASC
)
go

create index IDX_COMP_PURPOSE_ID on Company (
Purpose_ID ASC
)
go

create index IDX_COMP_COMMENTS_ID on Company (
Comments_ID ASC
)
go

create index IDX_COMP_DIRECTORSCOMMENTS_ID on Company (
DirectorsComments_ID ASC
)
go

create index IDX_COMP_ANNUALMEETINGNOTES_ID on Company (
AnnualMeetingNotes_ID ASC
)
go


insert into Company
select * from tmp_Company
go


--Reenable constraints

alter table AlternateName
   add constraint FK_ALTERNAT_REF_1426_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table CALURA
   add constraint FK_CALURA_REF_1180_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table Canada
   add constraint FK_CANADA_REF_1174_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table Chart
   add constraint FK_CHART_REF_1519_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    

alter table Company_Person
   add constraint FK_COMPANY__REF_1267_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    

alter table DBAName
   add constraint FK_DBANAME_REF_1172_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table FormerName
   add constraint FK_FORMERNA_REF_1173_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table InsurancePolicy
   add constraint FK_INSURANC_REF_1270_COMPANY foreign key (InsuranceCompany_ID)
      references Company (Company_ID)
go    
  
alter table Member
   add constraint FK_MEMBER_REF_1186_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table Ownership
   add constraint FK_OWNERSHI_REF_1178_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    
  
alter table Registration
   add constraint FK_REGISTRA_REF_1183_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go    

alter table Security
   add constraint FK_SECURITY_REF_1170_COMPANY foreign key (Company_ID)
      references Company (Company_ID)
go

alter table Company
   add constraint FK_COMPANY_REF_1006_ENTITY foreign key (Successor_EID)
      references Entity (Entity_EID)
go

alter table Company
   add constraint FK_COMPANY_REF_1018_LONGCOMM foreign key (Purpose_ID)
      references LongComments (Comments_ID)
go

alter table Company
   add constraint FK_COMPANY_REF_1221_LONGCOMM foreign key (Comments_ID)
      references LongComments (Comments_ID)
go

alter table Company
   add constraint FK_COMPANY_REF_1222_LONGCOMM foreign key (DirectorsComments_ID)
      references LongComments (Comments_ID)
go

alter table Company
   add constraint FK_COMPANY_REF_1269_ENTITY foreign key (Company_ID)
      references Entity (Entity_EID)
go

alter table Company
   add constraint FK_COMPANY_REF_1429_LONGCOMM foreign key (AnnualMeetingNotes_ID)
      references LongComments (Comments_ID)
go

drop table tmp_Company
go

---Matter
--disable constraint

alter table CalendarEvent
    DROP CONSTRAINT FK_CALENDAR_REF_1155_MATTER
go

alter table Document
    DROP CONSTRAINT FK_DOCUMENT_REF_1116_MATTER
go

alter table DocumentFile
    DROP CONSTRAINT FK_DOCUMENT_REF_1431_MATTER
go

alter table Evaluation
    DROP CONSTRAINT FK_EVALUATI_REF_1080_MATTER
go

alter table Evaluation
    DROP CONSTRAINT FK_EVALUATI_REF_3139_MATTER
go

alter table MatterAccrual
    DROP CONSTRAINT FK_MATTERAC_REF_3131_MATTER
go

alter table MatterBudget
    DROP CONSTRAINT FK_MATTERBU_REF_1126_MATTER
go

alter table MatterDamage
    DROP CONSTRAINT FK_MATTERDA_REF_1349_MATTER
go

alter table MatterExposure
    DROP CONSTRAINT FK_MATTEREX_REF_1135_MATTER
go

alter table MatterInsurancePolicy
    DROP CONSTRAINT FK_MATTERIN_REF_1131_MATTER
go

alter table MatterInvoice
    DROP CONSTRAINT FK_MATTERIN_REF_1311_MATTER
go

alter table MatterLitigation
    DROP CONSTRAINT FK_MATTERLI_REF_1129_MATTER
go

alter table MatterNegotiation
    DROP CONSTRAINT FK_MATTERNE_REF_1128_MATTER
go

alter table MatterPlayer
    DROP CONSTRAINT FK_MATTERPL_REF_1127_MATTER
go

alter table MatterRecovery
    DROP CONSTRAINT FK_MATTERRE_REF_1137_MATTER
go

alter table MatterRelationship
    DROP CONSTRAINT FK_MATTERRE_REF_1293_MATTER
go

alter table MatterRelationship
    DROP CONSTRAINT FK_MATTERRE_REF_1312_MATTER
go

alter table MatterReserve
    DROP CONSTRAINT FK_MATTERRE_REF_1328_MATTER
go

alter table Patent
    DROP CONSTRAINT FK_PATENT_REF_1160_MATTER
go

alter table PhysicalFile
    DROP CONSTRAINT FK_PHYSICAL_REF_1493_MATTER
go

alter table Trademark
    DROP CONSTRAINT FK_TRADEMAR_REF_1159_MATTER
go

alter table User_Matter
    DROP CONSTRAINT FK_USER_MAT_REF_1528_MATTER
go

alter table UserField
    DROP CONSTRAINT FK_USERFIEL_REF_3120_MATTER
go


if (select name from sysobjects
    where xtype = 'U'
    and name = 'tmp_Matter') = 'tmp_Matter'
begin
    drop table tmp_Matter
    print 'Dropped table.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

create table tmp_Matter (
MatterNumber_ID      int                  not null,
   Matter_CD            varchar(40)          not null,
   MatterStatus_CD      varchar(40)          null,
   LogicalGroup_ID      int                  null,
   MatterNumber         varchar(40)          not null,
   MatterName           varchar(200)         not null,
   FileNumber           varchar(20)          null,
   ProductService_CD    varchar(40)          null,
   SubProductService_CD varchar(40)          null,
   OpenDate             datetime             not null,
   OpenDate_ID          int                  null,
   CloseDate            datetime             null,
   CloseDate_ID         int                  null,
   ReOpenDate           datetime             null,
   ReOpenDate_ID        int                  null,
   Law_CD               varchar(40)          null,
   SubLaw_CD            varchar(40)          null,
   LongMatterName_ID    int                  null,
   LongMatterName       varchar(4000)        null,
   Comments_ID          int                  null,
   TargetDate           datetime             null,
   TargetDate_ID        int                  null,
   State_CD             varchar(40)          null,
   Country_CD           varchar(40)          null,
   Region_CD            varchar(40)          null,
   Litigated            char(1)              not null default 'F',
   LegalSection_CD      varchar(40)          not null,
   Budgeted             char(1)              not null default 'F',
   Insured              char(1)              not null default 'F',
   AccrueCosts          char(1)              not null default 'F',
   Priority_CD          varchar(40)          null,
   PrivateMatter        char(1)              null default 'F',
   PrivateChangeBy_ID   int                  null,
   PrivateChangeDate    datetime             null,
   Exported             char(1)              null default 'F',
   BillAfterClose       char(1)              null default 'T',
   eInvoicingMatterID   varchar(50)          null,
   NeedSync             char(1)              null default 'F',
   CollaboratiSync      char(1)              null default 'F',
   LHMatterID			varchar(50)			 null,
   ActiveHolds			int					 null,
   CreatedDate          datetime             null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   Matter_CAT           int                  not null,
   MatterStatus_CAT     int                  null,
   ProductService_CAT   int                  null,
   SubProductService_CAT int                  null,
   Law_CAT              int                  null,
   SubLaw_CAT           int                  null,
   State_CAT            int                  null,
   Country_CAT          int                  null,
   Region_CAT           int                  null,
   LegalSection_CAT     int                  not null,
   Priority_CAT         int                  null
)
go

insert into tmp_Matter
(
MatterNumber_ID,
   Matter_CD,
   MatterStatus_CD,
   LogicalGroup_ID,
   MatterNumber,
   MatterName,
   FileNumber,
   ProductService_CD,
   SubProductService_CD,
   OpenDate,
   OpenDate_ID,
   CloseDate,
   CloseDate_ID,
   ReOpenDate,
   ReOpenDate_ID,
   Law_CD,
   SubLaw_CD,
   LongMatterName_ID,
   LongMatterName,
   Comments_ID,
   TargetDate,
   TargetDate_ID,
   State_CD,
   Country_CD,
   Region_CD,
   Litigated,
   LegalSection_CD,
   Budgeted,
   Insured,
   AccrueCosts,
   Priority_CD,
   PrivateMatter,
   PrivateChangeBy_ID,
   PrivateChangeDate,
   Exported,
   BillAfterClose,
   eInvoicingMatterID,
   NeedSync,
   CollaboratiSync,
   CreatedDate,
   ChangeBy,
   LastChange,
   Matter_CAT,
   MatterStatus_CAT,
   ProductService_CAT,
   SubProductService_CAT,
   Law_CAT,
   SubLaw_CAT,
   State_CAT,
   Country_CAT,
   Region_CAT,
   LegalSection_CAT,
   Priority_CAT
)
select 
MatterNumber_ID,
   Matter_CD,
   MatterStatus_CD,
   LogicalGroup_ID,
   MatterNumber,
   MatterName,
   FileNumber,
   ProductService_CD,
   SubProductService_CD,
   OpenDate,
   OpenDate_ID,
   CloseDate,
   CloseDate_ID,
   ReOpenDate,
   ReOpenDate_ID,
   Law_CD,
   SubLaw_CD,
   LongMatterName_ID,
   LongMatterName,
   Comments_ID,
   TargetDate,
   TargetDate_ID,
   State_CD,
   Country_CD,
   Region_CD,
   Litigated,
   LegalSection_CD,
   Budgeted,
   Insured,
   AccrueCosts,
   Priority_CD,
   PrivateMatter,
   PrivateChangeBy_ID,
   PrivateChangeDate,
   Exported,
   BillAfterClose,
   eInvoicingMatterID,
   NeedSync,
   CollaboratiSync,
   CreatedDate,
   ChangeBy,
   LastChange,
   Matter_CAT,
   MatterStatus_CAT,
   ProductService_CAT,
   SubProductService_CAT,
   Law_CAT,
   SubLaw_CAT,
   State_CAT,
   Country_CAT,
   Region_CAT,
   LegalSection_CAT,
   Priority_CAT from Matter
   go
   
   drop table Matter
   go
   
   create table Matter (
   MatterNumber_ID      int                  not null,
   Matter_CD            varchar(40)          not null,
   MatterStatus_CD      varchar(40)          null,
   LogicalGroup_ID      int                  null,
   MatterNumber         varchar(40)          not null,
   MatterName           varchar(200)         not null,
   FileNumber           varchar(20)          null,
   ProductService_CD    varchar(40)          null,
   SubProductService_CD varchar(40)          null,
   OpenDate             datetime             not null,
   OpenDate_ID          int                  null,
   CloseDate            datetime             null,
   CloseDate_ID         int                  null,
   ReOpenDate           datetime             null,
   ReOpenDate_ID        int                  null,
   Law_CD               varchar(40)          null,
   SubLaw_CD            varchar(40)          null,
   LongMatterName_ID    int                  null,
   LongMatterName       varchar(4000)        null,
   Comments_ID          int                  null,
   TargetDate           datetime             null,
   TargetDate_ID        int                  null,
   State_CD             varchar(40)          null,
   Country_CD           varchar(40)          null,
   Region_CD            varchar(40)          null,
   Litigated            char(1)              not null default 'F',
   LegalSection_CD      varchar(40)          not null,
   Budgeted             char(1)              not null default 'F',
   Insured              char(1)              not null default 'F',
   AccrueCosts          char(1)              not null default 'F',
   Priority_CD          varchar(40)          null,
   PrivateMatter        char(1)              null default 'F',
   PrivateChangeBy_ID   int                  null,
   PrivateChangeDate    datetime             null,
   Exported             char(1)              null default 'F',
   BillAfterClose       char(1)              null default 'T',
   eInvoicingMatterID   varchar(50)          null,
   NeedSync             char(1)              null default 'F',
   CollaboratiSync      char(1)              null default 'F',
   LHMatterID			varchar(50)			 null,
   ActiveHolds			int					 null,
   CreatedDate          datetime             null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   Matter_CAT           int                  not null,
   MatterStatus_CAT     int                  null,
   ProductService_CAT   int                  null,
   SubProductService_CAT int                  null,
   Law_CAT              int                  null,
   SubLaw_CAT           int                  null,
   State_CAT            int                  null,
   Country_CAT          int                  null,
   Region_CAT           int                  null,
   LegalSection_CAT     int                  not null,
   Priority_CAT         int                  null,
   constraint PK_MATTER primary key (MatterNumber_ID)
)
go

create index IDX_MATT_MATTERNUMBER on Matter (
MatterNumber ASC
)
go

create index IDX_MATT_MATTERNAME on Matter (
MatterName ASC
)
go

create index IDX_MATT_LOGICALGROUP_ID on Matter (
LogicalGroup_ID ASC
)
go

create index IDX_MATT_COMMENTS_ID on Matter (
Comments_ID ASC
)
go

create index IDX_MATT_LONGMATTERNAME_ID on Matter (
LongMatterName_ID ASC
)
go

create index IDX_MATT_PRIVATECHANGEBY_ID on Matter (
PrivateChangeBy_ID ASC
)
go

create index IDX_MATT_PRIVATEMATTER on Matter (
PrivateMatter ASC
)
go

insert into Matter
select * from tmp_Matter
go

--Reenable constraints
alter table CalendarEvent
   add constraint FK_CALENDAR_REF_1155_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table Document
   add constraint FK_DOCUMENT_REF_1116_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table DocumentFile
   add constraint FK_DOCUMENT_REF_1431_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table Evaluation
   add constraint FK_EVALUATI_REF_1080_MATTER foreign key (RelatedMatter_ID)
      references Matter (MatterNumber_ID)
go

alter table Evaluation
   add constraint FK_EVALUATI_REF_3139_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterAccrual
   add constraint FK_MATTERAC_REF_3131_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterBudget
   add constraint FK_MATTERBU_REF_1126_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterDamage
   add constraint FK_MATTERDA_REF_1349_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterExposure
   add constraint FK_MATTEREX_REF_1135_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterInsurancePolicy
   add constraint FK_MATTERIN_REF_1131_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterInvoice
   add constraint FK_MATTERIN_REF_1311_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterLitigation
   add constraint FK_MATTERLI_REF_1129_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterNegotiation
   add constraint FK_MATTERNE_REF_1128_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterPlayer
   add constraint FK_MATTERPL_REF_1127_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterRecovery
   add constraint FK_MATTERRE_REF_1137_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterRelationship
   add constraint FK_MATTERRE_REF_1293_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterRelationship
   add constraint FK_MATTERRE_REF_1312_MATTER foreign key (RelatedMatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table MatterReserve
   add constraint FK_MATTERRE_REF_1328_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table Patent
   add constraint FK_PATENT_REF_1160_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table PhysicalFile
   add constraint FK_PHYSICAL_REF_1493_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table Trademark
   add constraint FK_TRADEMAR_REF_1159_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table User_Matter
   add constraint FK_USER_MAT_REF_1528_MATTER foreign key (MatterNumber_ID)
      references Matter (MatterNumber_ID)
go

alter table UserField
   add constraint FK_USERFIEL_REF_3120_MATTER foreign key (MatterField_ID)
      references Matter (MatterNumber_ID)
go

alter table Matter
   add constraint FK_MATTER_REF_1196_LOGICALG foreign key (LogicalGroup_ID)
      references LogicalGroup (LogicalGroup_ID)
go

alter table Matter
   add constraint FK_MATTER_REF_1234_LONGCOMM foreign key (Comments_ID)
      references LongComments (Comments_ID)
go

alter table Matter
   add constraint FK_MATTER_REF_1235_LONGCOMM foreign key (LongMatterName_ID)
      references LongComments (Comments_ID)
go

alter table Matter
   add constraint FK_MATTER_REF_1526_USERS foreign key (PrivateChangeBy_ID)
      references Users (User_ID)
go

drop table tmp_Matter
go

---Person
--disable constraint
   alter table Company_Person
    DROP CONSTRAINT FK_COMPANY__REF_1266_PERSON
go

alter table Court_Person
    DROP CONSTRAINT FK_COURT_PE_REF_1320_PERSON
go


if (select name from sysobjects
    where xtype = 'U'
    and name = 'tmp_Person') = 'tmp_Person'
begin
    drop table tmp_Matter
    print 'Dropped table.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

create table tmp_Person (
 Person_ID            int                  not null,
   LastName             varchar(30)          not null,
   FirstName            varchar(30)          null,
   Middle               varchar(30)          null,
   Suffix               varchar(20)          null,
   Salutation           varchar(15)          null,
   Nickname             varchar(15)          null,
   Initials             varchar(8)           null,
   AdministrationNumber varchar(20)          null,
   Employee             char(1)              null default 'F',
   EmployeeStartDate    datetime             null,
   EmployeeEndDate      datetime             null,
   Spouse               varchar(40)          null,
   SpouseSSN            varchar(20)          null,
   Gender               char(1)              null,
   EthnicClassification_CD varchar(40)          null,
   Secretary            varchar(40)          null,
   BirthDate            datetime             null,
   BirthPlace           varchar(100)         null,
   DeathDate            datetime             null,
   SecurityLevel        int                  null,
   CitizenJurisdiction_ID int                  null,
   PassportNumber       varchar(40)          null,
   DriversLicense       varchar(20)          null,
   DriversLicenseJurisdiction_ID int                  null,
   Timekeeper           char(1)              null,
   AssociatedTimekeeperID varchar(100)         null,
   TimekeeperSync       char(1)              null default 'F',
   eInvoicingTimekeeperID varchar(50)          null,
   eInvoicingAuthorized char(1)              null default 'F',
   StartOfWeek          varchar(15)          null,
   DailyMinumumHours    numeric(10,4)        null,
   DailyMaximumHours    numeric(10,4)        null,
   WeeklyMinimumHours   numeric(10,4)        null,
   WeeklyMaximumHours   numeric(10,4)        null,
   TimekeeperComments_ID int                  null,
   LHLegalHoldStaffID	varchar(50)			 null,
   Comments_ID          int                  null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   EthnicClassification_CAT int                  null
)

insert into tmp_Person
(
Person_ID,
   LastName,
   FirstName,
   Middle,
   Suffix,
   Salutation,
   Nickname,
   Initials,
   AdministrationNumber,
   Employee,
   EmployeeStartDate,
   EmployeeEndDate,
   Spouse,
   SpouseSSN,
   Gender,
   EthnicClassification_CD,
   Secretary,
   BirthDate,
   BirthPlace,
   DeathDate,
   SecurityLevel,
   CitizenJurisdiction_ID,
   PassportNumber,
   DriversLicense,
   DriversLicenseJurisdiction_ID,
   Timekeeper,
   AssociatedTimekeeperID,
   TimekeeperSync,
   eInvoicingTimekeeperID,
   eInvoicingAuthorized,
   StartOfWeek,
   DailyMinumumHours,
   DailyMaximumHours,
   WeeklyMinimumHours,
   WeeklyMaximumHours,
   TimekeeperComments_ID,
   Comments_ID,
   ChangeBy,
   LastChange,
   EthnicClassification_CAT
)
select 
Person_ID,
   LastName,
   FirstName,
   Middle,
   Suffix,
   Salutation,
   Nickname,
   Initials,
   AdministrationNumber,
   Employee,
   EmployeeStartDate,
   EmployeeEndDate,
   Spouse,
   SpouseSSN,
   Gender,
   EthnicClassification_CD,
   Secretary,
   BirthDate,
   BirthPlace,
   DeathDate,
   SecurityLevel,
   CitizenJurisdiction_ID,
   PassportNumber,
   DriversLicense,
   DriversLicenseJurisdiction_ID,
   Timekeeper,
   AssociatedTimekeeperID,
   TimekeeperSync,
   eInvoicingTimekeeperID,
   eInvoicingAuthorized,
   StartOfWeek,
   DailyMinumumHours,
   DailyMaximumHours,
   WeeklyMinimumHours,
   WeeklyMaximumHours,
   TimekeeperComments_ID,
   Comments_ID,
   ChangeBy,
   LastChange,
   EthnicClassification_CAT from Person
   go
   
drop table Person
go

create table Person (
   Person_ID            int                  not null,
   LastName             varchar(30)          not null,
   FirstName            varchar(30)          null,
   Middle               varchar(30)          null,
   Suffix               varchar(20)          null,
   Salutation           varchar(15)          null,
   Nickname             varchar(15)          null,
   Initials             varchar(8)           null,
   AdministrationNumber varchar(20)          null,
   Employee             char(1)              null default 'F',
   EmployeeStartDate    datetime             null,
   EmployeeEndDate      datetime             null,
   Spouse               varchar(40)          null,
   SpouseSSN            varchar(20)          null,
   Gender               char(1)              null,
   EthnicClassification_CD varchar(40)          null,
   Secretary            varchar(40)          null,
   BirthDate            datetime             null,
   BirthPlace           varchar(100)         null,
   DeathDate            datetime             null,
   SecurityLevel        int                  null,
   CitizenJurisdiction_ID int                  null,
   PassportNumber       varchar(40)          null,
   DriversLicense       varchar(20)          null,
   DriversLicenseJurisdiction_ID int                  null,
   Timekeeper           char(1)              null,
   AssociatedTimekeeperID varchar(100)         null,
   TimekeeperSync       char(1)              null default 'F',
   eInvoicingTimekeeperID varchar(50)          null,
   eInvoicingAuthorized char(1)              null default 'F',
   StartOfWeek          varchar(15)          null,
   DailyMinumumHours    numeric(10,4)        null,
   DailyMaximumHours    numeric(10,4)        null,
   WeeklyMinimumHours   numeric(10,4)        null,
   WeeklyMaximumHours   numeric(10,4)        null,
   TimekeeperComments_ID int                  null,
   LHLegalHoldStaffID	varchar(50)			 null,
   Comments_ID          int                  null,
   ChangeBy             varchar(20)          null,
   LastChange           datetime             null,
   EthnicClassification_CAT int                  null,
   constraint PK_PERSON primary key (Person_ID)
)
go

create index IDX_PERS_ADMINISTRATIONNUMBER on Person (
AdministrationNumber ASC
)
go

create index IDX_PERS_CITJURISDICTION_ID on Person (
CitizenJurisdiction_ID ASC
)
go

create index IDX_PERS_COMMENTS_ID on Person (
Comments_ID ASC
)
go

create index IDX_PERS_DRIVLICJUR_ID on Person (
DriversLicenseJurisdiction_ID ASC
)
go

create index IDX_PERS_TIMEKCOMMENTS_ID on Person (
TimekeeperComments_ID ASC
)
go

insert into Person
select * from tmp_Person
go

--Reenable constraints

alter table Company_Person
   add constraint FK_COMPANY__REF_1266_PERSON foreign key (Person_ID)
      references Person (Person_ID)
go	

alter table Court_Person
   add constraint FK_COURT_PE_REF_1320_PERSON foreign key (Person_ID)
      references Person (Person_ID)
go

alter table Person
   add constraint FK_PERSON_REF_1025_JURISDIC foreign key (CitizenJurisdiction_ID)
      references Jurisdiction (Jurisdiction_ID)
go

alter table Person
   add constraint FK_PERSON_REF_1066_ENTITY foreign key (Person_ID)
      references Entity (Entity_EID)
go

alter table Person
   add constraint FK_PERSON_REF_1212_LONGCOMM foreign key (Comments_ID)
      references LongComments (Comments_ID)
go

alter table Person
   add constraint FK_PERSON_REF_1351_JURISDIC foreign key (DriversLicenseJurisdiction_ID)
      references Jurisdiction (Jurisdiction_ID)
go

alter table Person
   add constraint FK_PERSON_REF_1447_LONGCOMM foreign key (TimekeeperComments_ID)
      references LongComments (Comments_ID)
go

drop table tmp_Person
go

	
---------------- End Structural Section ----------------

---------------- Begin Auditing Section ----------------

---Company

if (select name from sysobjects
    where xtype = 'U'
    and name = 'tmp_Company_Audit') = 'tmp_Company_Audit'
begin
    drop table tmp_Company_Audit
    print 'Dropped table.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
create table tmp_Company_Audit
(
old_Company_ID                       int            null,
    new_Company_ID                       int            null,
    old_AlternateName                    varchar(150)   null,
    new_AlternateName                    varchar(150)   null,
    old_AdministrationNumber             varchar(20)    null,
    new_AdministrationNumber             varchar(20)    null,
    old_InternalNumber                   varchar(40)    null,
    new_InternalNumber                   varchar(40)    null,
    old_FiscalYearEnd                    varchar(40)    null,
    new_FiscalYearEnd                    varchar(40)    null,
    old_TaxYearEnd                       varchar(40)    null,
    new_TaxYearEnd                       varchar(40)    null,
    old_HasEmployees                     char(1)        null,
    new_HasEmployees                     char(1)        null,
    old_Purpose_ID                       int            null,
    new_Purpose_ID                       int            null,
    old_AgreementDate                    datetime       null,
    new_AgreementDate                    datetime       null,
    old_TerminationDate                  datetime       null,
    new_TerminationDate                  datetime       null,
    old_AnnualMeetingMonth               int            null,
    new_AnnualMeetingMonth               int            null,
    old_AnnualMeetingNotes_ID            int            null,
    new_AnnualMeetingNotes_ID            int            null,
    old_AnnualMeetingDate                datetime       null,
    new_AnnualMeetingDate                datetime       null,
    old_DirectorsMin                     int            null,
    new_DirectorsMin                     int            null,
    old_DirectorsMax                     int            null,
    new_DirectorsMax                     int            null,
    old_DirectorsAuthorized              int            null,
    new_DirectorsAuthorized              int            null,
    old_DirectorsQuorum                  varchar(255)   null,
    new_DirectorsQuorum                  varchar(255)   null,
    old_BoardClasses                     int            null,
    new_BoardClasses                     int            null,
    old_BooksLocation                    varchar(255)   null,
    new_BooksLocation                    varchar(255)   null,
    old_SealLocation                     varchar(255)   null,
    new_SealLocation                     varchar(255)   null,
    old_Successor_EID                    int            null,
    new_Successor_EID                    int            null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_DirectorsComments_ID             int            null,
    new_DirectorsComments_ID             int            null,
    old_LastMeetingDate                  datetime       null,
    new_LastMeetingDate                  datetime       null,
    old_CorpStatusDate                   datetime       null,
    new_CorpStatusDate                   datetime       null,
    old_LLCGovernedBy                    int            null,
    new_LLCGovernedBy                    int            null,
    old_CompanyType_CD                   varchar(40)    null,
    new_CompanyType_CD                   varchar(40)    null,
    old_AccountCode                      varchar(40)    null,
    new_AccountCode                      varchar(40)    null,
    old_ChargeBackPct                    numeric(10,4)  null,
    new_ChargeBackPct                    numeric(10,4)  null,
    old_ChargeBackBeginDate              datetime       null,
    new_ChargeBackBeginDate              datetime       null,
    old_ChargeBackCode1                  varchar(100)    null,
    new_ChargeBackCode1                  varchar(100)    null,
    old_ChargeBackCode2                  varchar(100)    null,
    new_ChargeBackCode2                  varchar(100)    null,
    old_ChargeBackCode3                  varchar(100)    null,
    new_ChargeBackCode3                  varchar(100)    null,
    old_LineOfBusiness_CD                varchar(40)    null,
    new_LineOfBusiness_CD                varchar(40)    null,
    old_IsInsuranceCompany               char(1)        null,
    new_IsInsuranceCompany               char(1)        null,
    old_IsBillingEntity                  char(1)        null,
    new_IsBillingEntity                  char(1)        null,
    old_ExternalEntityNumber             varchar(20)    null,
    new_ExternalEntityNumber             varchar(20)    null,
	old_eInvoicingVendorID               varchar(50)    null,
    new_eInvoicingVendorID               varchar(50)    null,
	old_LHOrganizationID				 varchar(50)	null,
	new_LHOrganizationID				 varchar(50)	null,
    old_ApprovedFirm                     char(1)        null,
	new_ApprovedFirm                     char(1)        null,
    old_ApprovedDate                     datetime       null,
    new_ApprovedDate                     datetime       null,
    old_DismissalDate                    datetime       null,
    new_DismissalDate                    datetime       null,
    old_BillsCustomer                    char(1)        null,
    new_BillsCustomer                    char(1)        null,
    old_BillingMethod_CD                 varchar(40)    null,
    new_BillingMethod_CD                 varchar(40)    null,
    old_PaymentMethod_CD                 varchar(40)    null,
    new_PaymentMethod_CD                 varchar(40)    null,
    old_GuidelinesReturned               char(1)        null,
    new_GuidelinesReturned               char(1)        null,
    old_DateGuidelinesReturned           datetime       null,
    new_DateGuidelinesReturned           datetime       null,
    old_FemaleOwnership                  char(1)        null,
    new_FemaleOwnership                  char(1)        null,
    old_MinorityFirm                     char(1)        null,
    new_MinorityFirm                     char(1)        null,
    old_Domicile_CD                      varchar(40)    null,
    new_Domicile_CD                      varchar(40)    null,
    old_Region_CD                        varchar(40)    null,
    new_Region_CD                        varchar(40)    null,
    old_SubType_CD                       varchar(40)    null,
    new_SubType_CD                       varchar(40)    null,
    old_Reject                           char(1)        null,
    new_Reject                           char(1)        null,
    old_BeginDate                        datetime       null,
    new_BeginDate                        datetime       null,
    old_EndDate                          datetime       null,
    new_EndDate                          datetime       null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_CompanyType_CAT                  int            null,
    new_CompanyType_CAT                  int            null,
    old_LineOfBusiness_CAT               int            null,
    new_LineOfBusiness_CAT               int            null,
    old_BillingMethod_CAT                int            null,
    new_BillingMethod_CAT                int            null,
    old_PaymentMethod_CAT                int            null,
    new_PaymentMethod_CAT                int            null,
    old_Domicile_CAT                     int            null,
    new_Domicile_CAT                     int            null,
    old_Region_CAT                       int            null,
    new_Region_CAT                       int            null,
    old_SubType_CAT                      int            null,
    new_SubType_CAT                      int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
insert into tmp_Company_Audit
(
old_Company_ID,
    new_Company_ID,
    old_AlternateName,
    new_AlternateName,
    old_AdministrationNumber,
    new_AdministrationNumber,
    old_InternalNumber,
    new_InternalNumber,
    old_FiscalYearEnd,
    new_FiscalYearEnd,
    old_TaxYearEnd,
    new_TaxYearEnd,
    old_HasEmployees,
    new_HasEmployees,
    old_Purpose_ID,
    new_Purpose_ID,
    old_AgreementDate,
    new_AgreementDate,
    old_TerminationDate,
    new_TerminationDate,
    old_AnnualMeetingMonth,
    new_AnnualMeetingMonth,
    old_AnnualMeetingNotes_ID,
    new_AnnualMeetingNotes_ID,
    old_AnnualMeetingDate,
    new_AnnualMeetingDate,
    old_DirectorsMin,
    new_DirectorsMin,
    old_DirectorsMax,
    new_DirectorsMax,
    old_DirectorsAuthorized,
    new_DirectorsAuthorized,
    old_DirectorsQuorum,
    new_DirectorsQuorum,
    old_BoardClasses,
    new_BoardClasses,
    old_BooksLocation,
    new_BooksLocation,
    old_SealLocation,
    new_SealLocation,
    old_Successor_EID,
    new_Successor_EID,
    old_Comments_ID,
    new_Comments_ID,
    old_DirectorsComments_ID,
    new_DirectorsComments_ID,
    old_LastMeetingDate,
    new_LastMeetingDate,
    old_CorpStatusDate,
    new_CorpStatusDate,
    old_LLCGovernedBy,
    new_LLCGovernedBy,
    old_CompanyType_CD,
    new_CompanyType_CD,
    old_AccountCode,
    new_AccountCode,
    old_ChargeBackPct,
    new_ChargeBackPct,
    old_ChargeBackBeginDate,
    new_ChargeBackBeginDate,
    old_ChargeBackCode1,
    new_ChargeBackCode1,
    old_ChargeBackCode2,
    new_ChargeBackCode2,
    old_ChargeBackCode3,
    new_ChargeBackCode3,
    old_LineOfBusiness_CD,
    new_LineOfBusiness_CD,
    old_IsInsuranceCompany,
    new_IsInsuranceCompany,
    old_IsBillingEntity,
    new_IsBillingEntity,
    old_ExternalEntityNumber,
    new_ExternalEntityNumber,
	old_eInvoicingVendorID,
    new_eInvoicingVendorID,
    old_ApprovedFirm,
	new_ApprovedFirm,
    old_ApprovedDate,
    new_ApprovedDate,
    old_DismissalDate,
    new_DismissalDate,
    old_BillsCustomer,
    new_BillsCustomer,
    old_BillingMethod_CD,
    new_BillingMethod_CD,
    old_PaymentMethod_CD,
    new_PaymentMethod_CD,
    old_GuidelinesReturned,
    new_GuidelinesReturned,
    old_DateGuidelinesReturned,
    new_DateGuidelinesReturned,
    old_FemaleOwnership,
    new_FemaleOwnership,
    old_MinorityFirm,
    new_MinorityFirm,
    old_Domicile_CD,
    new_Domicile_CD,
    old_Region_CD,
    new_Region_CD,
    old_SubType_CD,
    new_SubType_CD,
    old_Reject,
    new_Reject,
    old_BeginDate,
    new_BeginDate,
    old_EndDate,
    new_EndDate,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_CompanyType_CAT,
    new_CompanyType_CAT,
    old_LineOfBusiness_CAT,
    new_LineOfBusiness_CAT,
    old_BillingMethod_CAT,
    new_BillingMethod_CAT,
    old_PaymentMethod_CAT,
    new_PaymentMethod_CAT,
    old_Domicile_CAT,
    new_Domicile_CAT,
    old_Region_CAT,
    new_Region_CAT,
    old_SubType_CAT,
    new_SubType_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate
)
select 
old_Company_ID,
    new_Company_ID,
    old_AlternateName,
    new_AlternateName,
    old_AdministrationNumber,
    new_AdministrationNumber,
    old_InternalNumber,
    new_InternalNumber,
    old_FiscalYearEnd,
    new_FiscalYearEnd,
    old_TaxYearEnd,
    new_TaxYearEnd,
    old_HasEmployees,
    new_HasEmployees,
    old_Purpose_ID,
    new_Purpose_ID,
    old_AgreementDate,
    new_AgreementDate,
    old_TerminationDate,
    new_TerminationDate,
    old_AnnualMeetingMonth,
    new_AnnualMeetingMonth,
    old_AnnualMeetingNotes_ID,
    new_AnnualMeetingNotes_ID,
    old_AnnualMeetingDate,
    new_AnnualMeetingDate,
    old_DirectorsMin,
    new_DirectorsMin,
    old_DirectorsMax,
    new_DirectorsMax,
    old_DirectorsAuthorized,
    new_DirectorsAuthorized,
    old_DirectorsQuorum,
    new_DirectorsQuorum,
    old_BoardClasses,
    new_BoardClasses,
    old_BooksLocation,
    new_BooksLocation,
    old_SealLocation,
    new_SealLocation,
    old_Successor_EID,
    new_Successor_EID,
    old_Comments_ID,
    new_Comments_ID,
    old_DirectorsComments_ID,
    new_DirectorsComments_ID,
    old_LastMeetingDate,
    new_LastMeetingDate,
    old_CorpStatusDate,
    new_CorpStatusDate,
    old_LLCGovernedBy,
    new_LLCGovernedBy,
    old_CompanyType_CD,
    new_CompanyType_CD,
    old_AccountCode,
    new_AccountCode,
    old_ChargeBackPct,
    new_ChargeBackPct,
    old_ChargeBackBeginDate,
    new_ChargeBackBeginDate,
    old_ChargeBackCode1,
    new_ChargeBackCode1,
    old_ChargeBackCode2,
    new_ChargeBackCode2,
    old_ChargeBackCode3,
    new_ChargeBackCode3,
    old_LineOfBusiness_CD,
    new_LineOfBusiness_CD,
    old_IsInsuranceCompany,
    new_IsInsuranceCompany,
    old_IsBillingEntity,
    new_IsBillingEntity,
    old_ExternalEntityNumber,
    new_ExternalEntityNumber,
	old_eInvoicingVendorID,
    new_eInvoicingVendorID,
    old_ApprovedFirm,
	new_ApprovedFirm,
    old_ApprovedDate,
    new_ApprovedDate,
    old_DismissalDate,
    new_DismissalDate,
    old_BillsCustomer,
    new_BillsCustomer,
    old_BillingMethod_CD,
    new_BillingMethod_CD,
    old_PaymentMethod_CD,
    new_PaymentMethod_CD,
    old_GuidelinesReturned,
    new_GuidelinesReturned,
    old_DateGuidelinesReturned,
    new_DateGuidelinesReturned,
    old_FemaleOwnership,
    new_FemaleOwnership,
    old_MinorityFirm,
    new_MinorityFirm,
    old_Domicile_CD,
    new_Domicile_CD,
    old_Region_CD,
    new_Region_CD,
    old_SubType_CD,
    new_SubType_CD,
    old_Reject,
    new_Reject,
    old_BeginDate,
    new_BeginDate,
    old_EndDate,
    new_EndDate,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_CompanyType_CAT,
    new_CompanyType_CAT,
    old_LineOfBusiness_CAT,
    new_LineOfBusiness_CAT,
    old_BillingMethod_CAT,
    new_BillingMethod_CAT,
    old_PaymentMethod_CAT,
    new_PaymentMethod_CAT,
    old_Domicile_CAT,
    new_Domicile_CAT,
    old_Region_CAT,
    new_Region_CAT,
    old_SubType_CAT,
    new_SubType_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate
	from Company_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
    drop table Company_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
create table Company_Audit
(
old_Company_ID                       int            null,
    new_Company_ID                       int            null,
    old_AlternateName                    varchar(150)   null,
    new_AlternateName                    varchar(150)   null,
    old_AdministrationNumber             varchar(20)    null,
    new_AdministrationNumber             varchar(20)    null,
    old_InternalNumber                   varchar(40)    null,
    new_InternalNumber                   varchar(40)    null,
    old_FiscalYearEnd                    varchar(40)    null,
    new_FiscalYearEnd                    varchar(40)    null,
    old_TaxYearEnd                       varchar(40)    null,
    new_TaxYearEnd                       varchar(40)    null,
    old_HasEmployees                     char(1)        null,
    new_HasEmployees                     char(1)        null,
    old_Purpose_ID                       int            null,
    new_Purpose_ID                       int            null,
    old_AgreementDate                    datetime       null,
    new_AgreementDate                    datetime       null,
    old_TerminationDate                  datetime       null,
    new_TerminationDate                  datetime       null,
    old_AnnualMeetingMonth               int            null,
    new_AnnualMeetingMonth               int            null,
    old_AnnualMeetingNotes_ID            int            null,
    new_AnnualMeetingNotes_ID            int            null,
    old_AnnualMeetingDate                datetime       null,
    new_AnnualMeetingDate                datetime       null,
    old_DirectorsMin                     int            null,
    new_DirectorsMin                     int            null,
    old_DirectorsMax                     int            null,
    new_DirectorsMax                     int            null,
    old_DirectorsAuthorized              int            null,
    new_DirectorsAuthorized              int            null,
    old_DirectorsQuorum                  varchar(255)   null,
    new_DirectorsQuorum                  varchar(255)   null,
    old_BoardClasses                     int            null,
    new_BoardClasses                     int            null,
    old_BooksLocation                    varchar(255)   null,
    new_BooksLocation                    varchar(255)   null,
    old_SealLocation                     varchar(255)   null,
    new_SealLocation                     varchar(255)   null,
    old_Successor_EID                    int            null,
    new_Successor_EID                    int            null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_DirectorsComments_ID             int            null,
    new_DirectorsComments_ID             int            null,
    old_LastMeetingDate                  datetime       null,
    new_LastMeetingDate                  datetime       null,
    old_CorpStatusDate                   datetime       null,
    new_CorpStatusDate                   datetime       null,
    old_LLCGovernedBy                    int            null,
    new_LLCGovernedBy                    int            null,
    old_CompanyType_CD                   varchar(40)    null,
    new_CompanyType_CD                   varchar(40)    null,
    old_AccountCode                      varchar(40)    null,
    new_AccountCode                      varchar(40)    null,
    old_ChargeBackPct                    numeric(10,4)  null,
    new_ChargeBackPct                    numeric(10,4)  null,
    old_ChargeBackBeginDate              datetime       null,
    new_ChargeBackBeginDate              datetime       null,
    old_ChargeBackCode1                  varchar(100)    null,
    new_ChargeBackCode1                  varchar(100)    null,
    old_ChargeBackCode2                  varchar(100)    null,
    new_ChargeBackCode2                  varchar(100)    null,
    old_ChargeBackCode3                  varchar(100)    null,
    new_ChargeBackCode3                  varchar(100)    null,
    old_LineOfBusiness_CD                varchar(40)    null,
    new_LineOfBusiness_CD                varchar(40)    null,
    old_IsInsuranceCompany               char(1)        null,
    new_IsInsuranceCompany               char(1)        null,
    old_IsBillingEntity                  char(1)        null,
    new_IsBillingEntity                  char(1)        null,
    old_ExternalEntityNumber             varchar(20)    null,
    new_ExternalEntityNumber             varchar(20)    null,
	old_eInvoicingVendorID               varchar(50)    null,
    new_eInvoicingVendorID               varchar(50)    null,
	old_LHOrganizationID				 varchar(50)	null,
	new_LHOrganizationID				 varchar(50)	null,
    old_ApprovedFirm                     char(1)        null,
	new_ApprovedFirm                     char(1)        null,
    old_ApprovedDate                     datetime       null,
    new_ApprovedDate                     datetime       null,
    old_DismissalDate                    datetime       null,
    new_DismissalDate                    datetime       null,
    old_BillsCustomer                    char(1)        null,
    new_BillsCustomer                    char(1)        null,
    old_BillingMethod_CD                 varchar(40)    null,
    new_BillingMethod_CD                 varchar(40)    null,
    old_PaymentMethod_CD                 varchar(40)    null,
    new_PaymentMethod_CD                 varchar(40)    null,
    old_GuidelinesReturned               char(1)        null,
    new_GuidelinesReturned               char(1)        null,
    old_DateGuidelinesReturned           datetime       null,
    new_DateGuidelinesReturned           datetime       null,
    old_FemaleOwnership                  char(1)        null,
    new_FemaleOwnership                  char(1)        null,
    old_MinorityFirm                     char(1)        null,
    new_MinorityFirm                     char(1)        null,
    old_Domicile_CD                      varchar(40)    null,
    new_Domicile_CD                      varchar(40)    null,
    old_Region_CD                        varchar(40)    null,
    new_Region_CD                        varchar(40)    null,
    old_SubType_CD                       varchar(40)    null,
    new_SubType_CD                       varchar(40)    null,
    old_Reject                           char(1)        null,
    new_Reject                           char(1)        null,
    old_BeginDate                        datetime       null,
    new_BeginDate                        datetime       null,
    old_EndDate                          datetime       null,
    new_EndDate                          datetime       null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_CompanyType_CAT                  int            null,
    new_CompanyType_CAT                  int            null,
    old_LineOfBusiness_CAT               int            null,
    new_LineOfBusiness_CAT               int            null,
    old_BillingMethod_CAT                int            null,
    new_BillingMethod_CAT                int            null,
    old_PaymentMethod_CAT                int            null,
    new_PaymentMethod_CAT                int            null,
    old_Domicile_CAT                     int            null,
    new_Domicile_CAT                     int            null,
    old_Region_CAT                       int            null,
    new_Region_CAT                       int            null,
    old_SubType_CAT                      int            null,
    new_SubType_CAT                      int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
    insert into Company_Audit
	select * from tmp_Company_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin    
	drop table tmp_Company_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

--Matter_Audit
if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin
create table tmp_Matter_Audit
(
old_MatterNumber_ID                  int            null,
    new_MatterNumber_ID                  int            null,
    old_Matter_CD                        varchar(40)    null,
    new_Matter_CD                        varchar(40)    null,
    old_MatterStatus_CD                  varchar(40)    null,
    new_MatterStatus_CD                  varchar(40)    null,
    old_LogicalGroup_ID                  int            null,
    new_LogicalGroup_ID                  int            null,
    old_MatterNumber                     varchar(40)    null,
    new_MatterNumber                     varchar(40)    null,
    old_MatterName                       varchar(200)    null,
    new_MatterName                       varchar(200)    null,
    old_FileNumber                       varchar(20)    null,
    new_FileNumber                       varchar(20)    null,
    old_ProductService_CD                varchar(40)    null,
    new_ProductService_CD                varchar(40)    null,
    old_SubProductService_CD             varchar(40)    null,
    new_SubProductService_CD             varchar(40)    null,
    old_OpenDate                         datetime       null,
    new_OpenDate                         datetime       null,
    old_OpenDate_ID                      int            null,
    new_OpenDate_ID                      int            null,
    old_CloseDate                        datetime       null,
    new_CloseDate                        datetime       null,
    old_CloseDate_ID                     int            null,
    new_CloseDate_ID                     int            null,
    old_ReOpenDate                       datetime       null,
    new_ReOpenDate                       datetime       null,
    old_ReOpenDate_ID                    int            null,
    new_ReOpenDate_ID                    int            null,
    old_Law_CD                           varchar(40)    null,
    new_Law_CD                           varchar(40)    null,
    old_SubLaw_CD                        varchar(40)    null,
    new_SubLaw_CD                        varchar(40)    null,
    old_LongMatterName_ID                int            null,
    new_LongMatterName_ID                int            null,
    old_LongMatterName                   text           null,
    new_LongMatterName                   text           null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_TargetDate                       datetime       null,
    new_TargetDate                       datetime       null,
    old_TargetDate_ID                    int            null,
    new_TargetDate_ID                    int            null,
    old_State_CD                         varchar(40)    null,
    new_State_CD                         varchar(40)    null,
    old_Country_CD                       varchar(40)    null,
    new_Country_CD                       varchar(40)    null,
    old_Region_CD                        varchar(40)    null,
    new_Region_CD                        varchar(40)    null,
    old_Litigated                        char(1)        null,
    new_Litigated                        char(1)        null,
    old_LegalSection_CD                  varchar(40)    null,
    new_LegalSection_CD                  varchar(40)    null,
    old_Budgeted                         char(1)        null,
    new_Budgeted                         char(1)        null,
    old_Insured                          char(1)        null,
    new_Insured                          char(1)        null,
    old_AccrueCosts                      char(1)        null,
    new_AccrueCosts                      char(1)        null,	
    old_Priority_CD                      varchar(40)    null,
    new_Priority_CD                      varchar(40)    null,
    old_PrivateMatter                    char(1)        null,
    new_PrivateMatter                    char(1)        null,
    old_PrivateChangeBy_ID               int            null,
    new_PrivateChangeBy_ID               int            null,
    old_PrivateChangeDate                datetime       null,
    new_PrivateChangeDate                datetime       null,
    old_Exported                         char(1)        null,
    new_Exported                         char(1)        null,
    old_BillAfterClose                   char(1)        null,
    new_BillAfterClose                   char(1)        null,
	old_eInvoicingMatterID               varchar(50)    null,
    new_eInvoicingMatterID               varchar(50)    null,
	old_NeedSync                         char(1)        null,
    new_NeedSync                         char(1)        null,
	old_CollaboratiSync                  char(1)        null,
    new_CollaboratiSync                  char(1)        null,
	old_LHMatterID						 varchar(50)	null,
	new_LHMatterID						 varchar(50)	null,
	old_ActiveHolds						 int			null,
	new_ActiveHolds						 int			null,
    old_CreatedDate                      datetime       null,
    new_CreatedDate                      datetime       null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_Matter_CAT                       int            null,
    new_Matter_CAT                       int            null,
    old_MatterStatus_CAT                 int            null,
    new_MatterStatus_CAT                 int            null,
    old_ProductService_CAT               int            null,
    new_ProductService_CAT               int            null,
    old_SubProductService_CAT            int            null,
    new_SubProductService_CAT            int            null,
    old_Law_CAT                          int            null,
    new_Law_CAT                          int            null,
    old_SubLaw_CAT                       int            null,
    new_SubLaw_CAT                       int            null,
    old_State_CAT                        int            null,
    new_State_CAT                        int            null,
    old_Country_CAT                      int            null,
    new_Country_CAT                      int            null,
    old_Region_CAT                       int            null,
    new_Region_CAT                       int            null,
    old_LegalSection_CAT                 int            null,
    new_LegalSection_CAT                 int            null,
    old_Priority_CAT                     int            null,
    new_Priority_CAT                     int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin
insert into tmp_Matter_Audit
(
old_MatterNumber_ID,
    new_MatterNumber_ID,
    old_Matter_CD,
    new_Matter_CD,
    old_MatterStatus_CD,
    new_MatterStatus_CD,
    old_LogicalGroup_ID,
    new_LogicalGroup_ID,
    old_MatterNumber,
    new_MatterNumber,
    old_MatterName,
    new_MatterName,
    old_FileNumber,
    new_FileNumber,
    old_ProductService_CD,
    new_ProductService_CD,
    old_SubProductService_CD,
    new_SubProductService_CD,
    old_OpenDate,
    new_OpenDate,
    old_OpenDate_ID,
    new_OpenDate_ID,
    old_CloseDate,
    new_CloseDate,
    old_CloseDate_ID,
    new_CloseDate_ID,
    old_ReOpenDate,
    new_ReOpenDate,
    old_ReOpenDate_ID,
    new_ReOpenDate_ID,
    old_Law_CD,
    new_Law_CD,
    old_SubLaw_CD,
    new_SubLaw_CD,
    old_LongMatterName_ID,
    new_LongMatterName_ID,
    old_LongMatterName,
    new_LongMatterName,
    old_Comments_ID,
    new_Comments_ID,
    old_TargetDate,
    new_TargetDate,
    old_TargetDate_ID,
    new_TargetDate_ID,
    old_State_CD,
    new_State_CD,
    old_Country_CD,
    new_Country_CD,
    old_Region_CD,
    new_Region_CD,
    old_Litigated,
    new_Litigated,
    old_LegalSection_CD,
    new_LegalSection_CD,
    old_Budgeted,
    new_Budgeted,
    old_Insured,
    new_Insured,
    old_AccrueCosts,
    new_AccrueCosts,	
    old_Priority_CD,
    new_Priority_CD,
    old_PrivateMatter,
    new_PrivateMatter,
    old_PrivateChangeBy_ID,
    new_PrivateChangeBy_ID,
    old_PrivateChangeDate,
    new_PrivateChangeDate,
    old_Exported,
    new_Exported,
    old_BillAfterClose,
    new_BillAfterClose,
	old_eInvoicingMatterID,
    new_eInvoicingMatterID,
	old_NeedSync,
    new_NeedSync,
	old_CollaboratiSync,
    new_CollaboratiSync,
    old_CreatedDate,
    new_CreatedDate,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_Matter_CAT,
    new_Matter_CAT,
    old_MatterStatus_CAT,
    new_MatterStatus_CAT,
    old_ProductService_CAT,
    new_ProductService_CAT,
    old_SubProductService_CAT,
    new_SubProductService_CAT,
    old_Law_CAT,
    new_Law_CAT,
    old_SubLaw_CAT,
    new_SubLaw_CAT,
    old_State_CAT,
    new_State_CAT,
    old_Country_CAT,
    new_Country_CAT,
    old_Region_CAT,
    new_Region_CAT,
    old_LegalSection_CAT,
    new_LegalSection_CAT,
    old_Priority_CAT,
    new_Priority_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate
)
select 
old_MatterNumber_ID,
    new_MatterNumber_ID,
    old_Matter_CD,
    new_Matter_CD,
    old_MatterStatus_CD,
    new_MatterStatus_CD,
    old_LogicalGroup_ID,
    new_LogicalGroup_ID,
    old_MatterNumber,
    new_MatterNumber,
    old_MatterName,
    new_MatterName,
    old_FileNumber,
    new_FileNumber,
    old_ProductService_CD,
    new_ProductService_CD,
    old_SubProductService_CD,
    new_SubProductService_CD,
    old_OpenDate,
    new_OpenDate,
    old_OpenDate_ID,
    new_OpenDate_ID,
    old_CloseDate,
    new_CloseDate,
    old_CloseDate_ID,
    new_CloseDate_ID,
    old_ReOpenDate,
    new_ReOpenDate,
    old_ReOpenDate_ID,
    new_ReOpenDate_ID,
    old_Law_CD,
    new_Law_CD,
    old_SubLaw_CD,
    new_SubLaw_CD,
    old_LongMatterName_ID,
    new_LongMatterName_ID,
    old_LongMatterName,
    new_LongMatterName,
    old_Comments_ID,
    new_Comments_ID,
    old_TargetDate,
    new_TargetDate,
    old_TargetDate_ID,
    new_TargetDate_ID,
    old_State_CD,
    new_State_CD,
    old_Country_CD,
    new_Country_CD,
    old_Region_CD,
    new_Region_CD,
    old_Litigated,
    new_Litigated,
    old_LegalSection_CD,
    new_LegalSection_CD,
    old_Budgeted,
    new_Budgeted,
    old_Insured,
    new_Insured,
    old_AccrueCosts,
    new_AccrueCosts,	
    old_Priority_CD,
    new_Priority_CD,
    old_PrivateMatter,
    new_PrivateMatter,
    old_PrivateChangeBy_ID,
    new_PrivateChangeBy_ID,
    old_PrivateChangeDate,
    new_PrivateChangeDate,
    old_Exported,
    new_Exported,
    old_BillAfterClose,
    new_BillAfterClose,
	old_eInvoicingMatterID,
    new_eInvoicingMatterID,
	old_NeedSync,
    new_NeedSync,
	old_CollaboratiSync,
    new_CollaboratiSync,
    old_CreatedDate,
    new_CreatedDate,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_Matter_CAT,
    new_Matter_CAT,
    old_MatterStatus_CAT,
    new_MatterStatus_CAT,
    old_ProductService_CAT,
    new_ProductService_CAT,
    old_SubProductService_CAT,
    new_SubProductService_CAT,
    old_Law_CAT,
    new_Law_CAT,
    old_SubLaw_CAT,
    new_SubLaw_CAT,
    old_State_CAT,
    new_State_CAT,
    old_Country_CAT,
    new_Country_CAT,
    old_Region_CAT,
    new_Region_CAT,
    old_LegalSection_CAT,
    new_LegalSection_CAT,
    old_Priority_CAT,
    new_Priority_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate
	from Matter_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin    
	drop table Matter_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin    
	create table Matter_Audit
(
old_MatterNumber_ID                  int            null,
    new_MatterNumber_ID                  int            null,
    old_Matter_CD                        varchar(40)    null,
    new_Matter_CD                        varchar(40)    null,
    old_MatterStatus_CD                  varchar(40)    null,
    new_MatterStatus_CD                  varchar(40)    null,
    old_LogicalGroup_ID                  int            null,
    new_LogicalGroup_ID                  int            null,
    old_MatterNumber                     varchar(40)    null,
    new_MatterNumber                     varchar(40)    null,
    old_MatterName                       varchar(200)    null,
    new_MatterName                       varchar(200)    null,
    old_FileNumber                       varchar(20)    null,
    new_FileNumber                       varchar(20)    null,
    old_ProductService_CD                varchar(40)    null,
    new_ProductService_CD                varchar(40)    null,
    old_SubProductService_CD             varchar(40)    null,
    new_SubProductService_CD             varchar(40)    null,
    old_OpenDate                         datetime       null,
    new_OpenDate                         datetime       null,
    old_OpenDate_ID                      int            null,
    new_OpenDate_ID                      int            null,
    old_CloseDate                        datetime       null,
    new_CloseDate                        datetime       null,
    old_CloseDate_ID                     int            null,
    new_CloseDate_ID                     int            null,
    old_ReOpenDate                       datetime       null,
    new_ReOpenDate                       datetime       null,
    old_ReOpenDate_ID                    int            null,
    new_ReOpenDate_ID                    int            null,
    old_Law_CD                           varchar(40)    null,
    new_Law_CD                           varchar(40)    null,
    old_SubLaw_CD                        varchar(40)    null,
    new_SubLaw_CD                        varchar(40)    null,
    old_LongMatterName_ID                int            null,
    new_LongMatterName_ID                int            null,
    old_LongMatterName                   text           null,
    new_LongMatterName                   text           null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_TargetDate                       datetime       null,
    new_TargetDate                       datetime       null,
    old_TargetDate_ID                    int            null,
    new_TargetDate_ID                    int            null,
    old_State_CD                         varchar(40)    null,
    new_State_CD                         varchar(40)    null,
    old_Country_CD                       varchar(40)    null,
    new_Country_CD                       varchar(40)    null,
    old_Region_CD                        varchar(40)    null,
    new_Region_CD                        varchar(40)    null,
    old_Litigated                        char(1)        null,
    new_Litigated                        char(1)        null,
    old_LegalSection_CD                  varchar(40)    null,
    new_LegalSection_CD                  varchar(40)    null,
    old_Budgeted                         char(1)        null,
    new_Budgeted                         char(1)        null,
    old_Insured                          char(1)        null,
    new_Insured                          char(1)        null,
    old_AccrueCosts                      char(1)        null,
    new_AccrueCosts                      char(1)        null,	
    old_Priority_CD                      varchar(40)    null,
    new_Priority_CD                      varchar(40)    null,
    old_PrivateMatter                    char(1)        null,
    new_PrivateMatter                    char(1)        null,
    old_PrivateChangeBy_ID               int            null,
    new_PrivateChangeBy_ID               int            null,
    old_PrivateChangeDate                datetime       null,
    new_PrivateChangeDate                datetime       null,
    old_Exported                         char(1)        null,
    new_Exported                         char(1)        null,
    old_BillAfterClose                   char(1)        null,
    new_BillAfterClose                   char(1)        null,
	old_eInvoicingMatterID               varchar(50)    null,
    new_eInvoicingMatterID               varchar(50)    null,
	old_NeedSync                         char(1)        null,
    new_NeedSync                         char(1)        null,
	old_CollaboratiSync                  char(1)        null,
    new_CollaboratiSync                  char(1)        null,
	old_LHMatterID						 varchar(50)	null,
	new_LHMatterID						 varchar(50)	null,
	old_ActiveHolds						 int			null,
	new_ActiveHolds						 int			null,
    old_CreatedDate                      datetime       null,
    new_CreatedDate                      datetime       null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_Matter_CAT                       int            null,
    new_Matter_CAT                       int            null,
    old_MatterStatus_CAT                 int            null,
    new_MatterStatus_CAT                 int            null,
    old_ProductService_CAT               int            null,
    new_ProductService_CAT               int            null,
    old_SubProductService_CAT            int            null,
    new_SubProductService_CAT            int            null,
    old_Law_CAT                          int            null,
    new_Law_CAT                          int            null,
    old_SubLaw_CAT                       int            null,
    new_SubLaw_CAT                       int            null,
    old_State_CAT                        int            null,
    new_State_CAT                        int            null,
    old_Country_CAT                      int            null,
    new_Country_CAT                      int            null,
    old_Region_CAT                       int            null,
    new_Region_CAT                       int            null,
    old_LegalSection_CAT                 int            null,
    new_LegalSection_CAT                 int            null,
    old_Priority_CAT                     int            null,
    new_Priority_CAT                     int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)	
end
else
    print 'The command(s) completed successfully.'
    print ''
go


if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin
    insert into Matter_Audit
	select * from tmp_Matter_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin    
	drop table tmp_Matter_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

--Person
if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
create table tmp_Person_Audit
(
 old_Person_ID                        int            null,
    new_Person_ID                        int            null,
    old_LastName                         varchar(30)    null,
    new_LastName                         varchar(30)    null,
    old_FirstName                        varchar(30)    null,
    new_FirstName                        varchar(30)    null,
    old_Middle                           varchar(30)    null,
    new_Middle                           varchar(30)    null,
    old_Suffix                           varchar(20)    null,
    new_Suffix                           varchar(20)    null,
    old_Salutation                       varchar(15)    null,
    new_Salutation                       varchar(15)    null,
    old_Nickname                         varchar(15)    null,
    new_Nickname                         varchar(15)    null,
	old_Initials                         varchar(8)     null,
    new_initials                         varchar(8)     null,
    old_AdministrationNumber             varchar(20)    null,
    new_AdministrationNumber             varchar(20)    null,
    old_Employee                         char(1)        null,
    new_Employee                         char(1)        null,
    old_EmployeeStartDate                datetime       null,
    new_EmployeeStartDate                datetime       null,
    old_EmployeeEndDate                  datetime       null,
    new_EmployeeEndDate                  datetime       null,
    old_Spouse                           varchar(40)    null,
    new_Spouse                           varchar(40)    null,
    old_SpouseSSN                        varchar(20)    null,
    new_SpouseSSN                        varchar(20)    null,
    old_Gender                           char(1)        null,
    new_Gender                           char(1)        null,
    old_EthnicClassification_CD          varchar(40)    null,
    new_EthnicClassification_CD          varchar(40)    null,
    old_Secretary                        varchar(40)    null,
    new_Secretary                        varchar(40)    null,
    old_BirthDate                        datetime       null,
    new_BirthDate                        datetime       null,
    old_BirthPlace                       varchar(100)   null,
    new_BirthPlace                       varchar(100)   null,
    old_DeathDate                        datetime       null,
    new_DeathDate                        datetime       null,
    old_SecurityLevel                    int            null,
    new_SecurityLevel                    int            null,
    old_CitizenJurisdiction_ID           int            null,
    new_CitizenJurisdiction_ID           int            null,
    old_PassportNumber                   varchar(40)    null,
    new_PassportNumber                   varchar(40)    null,
    old_DriversLicense                   varchar(20)    null,
    new_DriversLicense                   varchar(20)    null,
    old_DriversLicenseJurisdiction_ID    int            null,
    new_DriversLicenseJurisdiction_ID    int            null,
    old_Timekeeper                       char(1)        null,
    new_Timekeeper                       char(1)        null,
    old_AssociatedTimekeeperID           varchar(100)   null,
    new_AssociatedTimekeeperID           varchar(100)   null,
    old_TimekeeperSync                   char(1)        null,
    new_TimekeeperSync                   char(1)        null,
	old_eInvoicingTimekeeperID			 varchar(50)    null,
	new_eInvoicingTimekeeperID			 varchar(50)    null,
	old_eInvoicingAuthorized             char(1)        null,
    new_eInvoicingAuthorized             char(1)        null,
    old_StartOfWeek                      varchar(15)    null,
    new_StartOfWeek                      varchar(15)    null,
    old_DailyMinumumHours                numeric(10,4)  null,
    new_DailyMinumumHours                numeric(10,4)  null,
    old_DailyMaximumHours                numeric(10,4)  null,
    new_DailyMaximumHours                numeric(10,4)  null,
    old_WeeklyMinimumHours               numeric(10,4)  null,
    new_WeeklyMinimumHours               numeric(10,4)  null,
    old_WeeklyMaximumHours               numeric(10,4)  null,
    new_WeeklyMaximumHours               numeric(10,4)  null,
    old_TimekeeperComments_ID            int            null,
    new_TimekeeperComments_ID            int            null,
	old_LHLegalHoldStaffID				 varchar(50)	null,
	new_LHLegalHoldStaffID				 varchar(50)	null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_EthnicClassification_CAT         int            null,
    new_EthnicClassification_CAT         int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
insert into tmp_Person_Audit
(
 old_Person_ID,
    new_Person_ID,
    old_LastName,
    new_LastName,
    old_FirstName,
    new_FirstName,
    old_Middle,
    new_Middle,
    old_Suffix,
    new_Suffix,
    old_Salutation,
    new_Salutation,
    old_Nickname,
    new_Nickname,
	old_Initials,
    new_initials,
    old_AdministrationNumber,
    new_AdministrationNumber,
    old_Employee,
    new_Employee,
    old_EmployeeStartDate,
    new_EmployeeStartDate,
    old_EmployeeEndDate,
    new_EmployeeEndDate,
    old_Spouse,
    new_Spouse,
    old_SpouseSSN,
    new_SpouseSSN,
    old_Gender,
    new_Gender,
    old_EthnicClassification_CD,
    new_EthnicClassification_CD,
    old_Secretary,
    new_Secretary,
    old_BirthDate,
    new_BirthDate,
    old_BirthPlace,
    new_BirthPlace,
    old_DeathDate,
    new_DeathDate,
    old_SecurityLevel,
    new_SecurityLevel,
    old_CitizenJurisdiction_ID,
    new_CitizenJurisdiction_ID,
    old_PassportNumber,
    new_PassportNumber,
    old_DriversLicense,
    new_DriversLicense,
    old_DriversLicenseJurisdiction_ID,
    new_DriversLicenseJurisdiction_ID,
    old_Timekeeper,
    new_Timekeeper,
    old_AssociatedTimekeeperID,
    new_AssociatedTimekeeperID,
    old_TimekeeperSync,
    new_TimekeeperSync,
	old_eInvoicingTimekeeperID,
	new_eInvoicingTimekeeperID,
	old_eInvoicingAuthorized,
    new_eInvoicingAuthorized,
    old_StartOfWeek,
    new_StartOfWeek,
    old_DailyMinumumHours,
    new_DailyMinumumHours,
    old_DailyMaximumHours,
    new_DailyMaximumHours,
    old_WeeklyMinimumHours,
    new_WeeklyMinimumHours,
    old_WeeklyMaximumHours,
    new_WeeklyMaximumHours,
    old_TimekeeperComments_ID,
    new_TimekeeperComments_ID,
    old_Comments_ID,
    new_Comments_ID,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_EthnicClassification_CAT,
    new_EthnicClassification_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate	
	)
	select 
	 old_Person_ID,
    new_Person_ID,
    old_LastName,
    new_LastName,
    old_FirstName,
    new_FirstName,
    old_Middle,
    new_Middle,
    old_Suffix,
    new_Suffix,
    old_Salutation,
    new_Salutation,
    old_Nickname,
    new_Nickname,
	old_Initials,
    new_initials,
    old_AdministrationNumber,
    new_AdministrationNumber,
    old_Employee,
    new_Employee,
    old_EmployeeStartDate,
    new_EmployeeStartDate,
    old_EmployeeEndDate,
    new_EmployeeEndDate,
    old_Spouse,
    new_Spouse,
    old_SpouseSSN,
    new_SpouseSSN,
    old_Gender,
    new_Gender,
    old_EthnicClassification_CD,
    new_EthnicClassification_CD,
    old_Secretary,
    new_Secretary,
    old_BirthDate,
    new_BirthDate,
    old_BirthPlace,
    new_BirthPlace,
    old_DeathDate,
    new_DeathDate,
    old_SecurityLevel,
    new_SecurityLevel,
    old_CitizenJurisdiction_ID,
    new_CitizenJurisdiction_ID,
    old_PassportNumber,
    new_PassportNumber,
    old_DriversLicense,
    new_DriversLicense,
    old_DriversLicenseJurisdiction_ID,
    new_DriversLicenseJurisdiction_ID,
    old_Timekeeper,
    new_Timekeeper,
    old_AssociatedTimekeeperID,
    new_AssociatedTimekeeperID,
    old_TimekeeperSync,
    new_TimekeeperSync,
	old_eInvoicingTimekeeperID,
	new_eInvoicingTimekeeperID,
	old_eInvoicingAuthorized,
    new_eInvoicingAuthorized,
    old_StartOfWeek,
    new_StartOfWeek,
    old_DailyMinumumHours,
    new_DailyMinumumHours,
    old_DailyMaximumHours,
    new_DailyMaximumHours,
    old_WeeklyMinimumHours,
    new_WeeklyMinimumHours,
    old_WeeklyMaximumHours,
    new_WeeklyMaximumHours,
    old_TimekeeperComments_ID,
    new_TimekeeperComments_ID,
    old_Comments_ID,
    new_Comments_ID,
    old_ChangeBy,
    new_ChangeBy,
    old_LastChange,
    new_LastChange,
    old_EthnicClassification_CAT,
    new_EthnicClassification_CAT,
    Transaction_ID,
    TransactionType,
    TransactionUser,
    TransactionDate	from Person_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
drop table Person_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
create table Person_Audit
(
 old_Person_ID                        int            null,
    new_Person_ID                        int            null,
    old_LastName                         varchar(30)    null,
    new_LastName                         varchar(30)    null,
    old_FirstName                        varchar(30)    null,
    new_FirstName                        varchar(30)    null,
    old_Middle                           varchar(30)    null,
    new_Middle                           varchar(30)    null,
    old_Suffix                           varchar(20)    null,
    new_Suffix                           varchar(20)    null,
    old_Salutation                       varchar(15)    null,
    new_Salutation                       varchar(15)    null,
    old_Nickname                         varchar(15)    null,
    new_Nickname                         varchar(15)    null,
	old_Initials                         varchar(8)     null,
    new_initials                         varchar(8)     null,
    old_AdministrationNumber             varchar(20)    null,
    new_AdministrationNumber             varchar(20)    null,
    old_Employee                         char(1)        null,
    new_Employee                         char(1)        null,
    old_EmployeeStartDate                datetime       null,
    new_EmployeeStartDate                datetime       null,
    old_EmployeeEndDate                  datetime       null,
    new_EmployeeEndDate                  datetime       null,
    old_Spouse                           varchar(40)    null,
    new_Spouse                           varchar(40)    null,
    old_SpouseSSN                        varchar(20)    null,
    new_SpouseSSN                        varchar(20)    null,
    old_Gender                           char(1)        null,
    new_Gender                           char(1)        null,
    old_EthnicClassification_CD          varchar(40)    null,
    new_EthnicClassification_CD          varchar(40)    null,
    old_Secretary                        varchar(40)    null,
    new_Secretary                        varchar(40)    null,
    old_BirthDate                        datetime       null,
    new_BirthDate                        datetime       null,
    old_BirthPlace                       varchar(100)   null,
    new_BirthPlace                       varchar(100)   null,
    old_DeathDate                        datetime       null,
    new_DeathDate                        datetime       null,
    old_SecurityLevel                    int            null,
    new_SecurityLevel                    int            null,
    old_CitizenJurisdiction_ID           int            null,
    new_CitizenJurisdiction_ID           int            null,
    old_PassportNumber                   varchar(40)    null,
    new_PassportNumber                   varchar(40)    null,
    old_DriversLicense                   varchar(20)    null,
    new_DriversLicense                   varchar(20)    null,
    old_DriversLicenseJurisdiction_ID    int            null,
    new_DriversLicenseJurisdiction_ID    int            null,
    old_Timekeeper                       char(1)        null,
    new_Timekeeper                       char(1)        null,
    old_AssociatedTimekeeperID           varchar(100)   null,
    new_AssociatedTimekeeperID           varchar(100)   null,
    old_TimekeeperSync                   char(1)        null,
    new_TimekeeperSync                   char(1)        null,
	old_eInvoicingTimekeeperID			 varchar(50)    null,
	new_eInvoicingTimekeeperID			 varchar(50)    null,
	old_eInvoicingAuthorized             char(1)        null,
    new_eInvoicingAuthorized             char(1)        null,
    old_StartOfWeek                      varchar(15)    null,
    new_StartOfWeek                      varchar(15)    null,
    old_DailyMinumumHours                numeric(10,4)  null,
    new_DailyMinumumHours                numeric(10,4)  null,
    old_DailyMaximumHours                numeric(10,4)  null,
    new_DailyMaximumHours                numeric(10,4)  null,
    old_WeeklyMinimumHours               numeric(10,4)  null,
    new_WeeklyMinimumHours               numeric(10,4)  null,
    old_WeeklyMaximumHours               numeric(10,4)  null,
    new_WeeklyMaximumHours               numeric(10,4)  null,
    old_TimekeeperComments_ID            int            null,
    new_TimekeeperComments_ID            int            null,
	old_LHLegalHoldStaffID				 varchar(50)	null,
	new_LHLegalHoldStaffID				 varchar(50)	null,
    old_Comments_ID                      int            null,
    new_Comments_ID                      int            null,
    old_ChangeBy                         varchar(20)    null,
    new_ChangeBy                         varchar(20)    null,
    old_LastChange                       datetime       null,
    new_LastChange                       datetime       null,
    old_EthnicClassification_CAT         int            null,
    new_EthnicClassification_CAT         int            null,
    Transaction_ID                       numeric(27,0)  null,
    TransactionType                      char(1)        null,
    TransactionUser                      varchar(20)    null,
    TransactionDate                      datetime       null
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
insert into Person_Audit
select * from tmp_Person_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin    
drop table tmp_Person_Audit
end
else
    print 'The command(s) completed successfully.'
    print ''
go
-- End Audit table changes

-- Begin Audit trigger changes

--Company
if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Company') = 'Audit_Company'
begin
    drop trigger Audit_Company
    print 'Dropped trigger.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTrigger from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
declare @strSQLa   varchar(max)

set @strSQLa =
'create trigger Audit_Company on Company for insert, update, delete
as
declare @UserSID           int,
        @TransactionUser   varchar(20),
        @TransactionDate   datetime

        select  @UserSID = (select @@SPID),
          @TransactionDate = getdate()

        select  @TransactionUser = (select LoginName from AuditUserSID where UserSID = @UserSID and LoginDate > dateadd(mi,-5,getdate()))

        if @TransactionUser is null
           select @TransactionUser = ''Unknown''

        if exists (select * from inserted) and exists (select * from deleted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''U'', @TransactionUser, @TransactionDate, ''COMPANY'') 
          insert Company_Audit
            (
             old_AccountCode,
             old_AdministrationNumber,
             old_AgreementDate,
             old_AlternateName,
             old_AnnualMeetingDate,
             old_AnnualMeetingMonth,
             old_AnnualMeetingNotes_ID,
             old_ApprovedDate,
             old_ApprovedFirm,
             old_BeginDate,
             old_BillingMethod_CAT,
             old_BillingMethod_CD,
             old_BillsCustomer,
             old_BoardClasses,
             old_BooksLocation,
             old_ChangeBy,
             old_ChargeBackBeginDate,
             old_ChargeBackCode1,
             old_ChargeBackCode2,
             old_ChargeBackCode3,
             old_ChargeBackPct,
             old_Comments_ID,
             old_Company_ID,
             old_CompanyType_CAT,
             old_CompanyType_CD,
             old_CorpStatusDate,
             old_DateGuidelinesReturned,
             old_DirectorsAuthorized,
             old_DirectorsComments_ID,
             old_DirectorsMax,
             old_DirectorsMin,
             old_DirectorsQuorum,
             old_DismissalDate,
             old_Domicile_CAT,
             old_Domicile_CD,
             old_EndDate,
             old_ExternalEntityNumber,
			 old_eInvoicingVendorID,
             old_FemaleOwnership,
             old_FiscalYearEnd,
             old_GuidelinesReturned,
             old_HasEmployees,
             old_InternalNumber,
             old_IsBillingEntity,
             old_IsInsuranceCompany,
             old_LastChange,
             old_LastMeetingDate,
			 old_LHorganizationID,
             old_LineOfBusiness_CAT,
             old_LineOfBusiness_CD,
             old_LLCGovernedBy,
             old_MinorityFirm,
             old_PaymentMethod_CAT,
             old_PaymentMethod_CD,
             old_Purpose_ID,
             old_Region_CAT,
             old_Region_CD,
             old_Reject,
             old_SealLocation,
             old_SubType_CAT,
             old_SubType_CD,
             old_Successor_EID,
             old_TaxYearEnd,
             old_TerminationDate,
             new_AccountCode,
             new_AdministrationNumber,
             new_AgreementDate,
             new_AlternateName,
             new_AnnualMeetingDate,
             new_AnnualMeetingMonth,
             new_AnnualMeetingNotes_ID,
             new_ApprovedDate,
             new_ApprovedFirm,
             new_BeginDate,
             new_BillingMethod_CAT,
             new_BillingMethod_CD,
             new_BillsCustomer,
             new_BoardClasses,
             new_BooksLocation,
             new_ChangeBy,
             new_ChargeBackBeginDate,
             new_ChargeBackCode1,
             new_ChargeBackCode2,
             new_ChargeBackCode3,
             new_ChargeBackPct,
             new_Comments_ID,
             new_Company_ID,
             new_CompanyType_CAT,
             new_CompanyType_CD,
             new_CorpStatusDate,
             new_DateGuidelinesReturned,
             new_DirectorsAuthorized,
             new_DirectorsComments_ID,
             new_DirectorsMax,
             new_DirectorsMin,
             new_DirectorsQuorum,
             new_DismissalDate,
             new_Domicile_CAT,
             new_Domicile_CD,
             new_EndDate,
             new_ExternalEntityNumber,
			 new_eInvoicingVendorID,
             new_FemaleOwnership,
             new_FiscalYearEnd,
             new_GuidelinesReturned,
             new_HasEmployees,
             new_InternalNumber,
             new_IsBillingEntity,
             new_IsInsuranceCompany,
             new_LastChange,
             new_LastMeetingDate,
			 new_LHorganizationID,
             new_LineOfBusiness_CAT,
             new_LineOfBusiness_CD,
             new_LLCGovernedBy,
             new_MinorityFirm,
             new_PaymentMethod_CAT,
             new_PaymentMethod_CD,
             new_Purpose_ID,
             new_Region_CAT,
             new_Region_CD,
             new_Reject,
             new_SealLocation,
             new_SubType_CAT,
             new_SubType_CD,
             new_Successor_EID,
             new_TaxYearEnd,
             new_TerminationDate,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            old.AccountCode,
            old.AdministrationNumber,
            old.AgreementDate,
            old.AlternateName,
            old.AnnualMeetingDate,
            old.AnnualMeetingMonth,
            old.AnnualMeetingNotes_ID,
            old.ApprovedDate,
            old.ApprovedFirm,
            old.BeginDate,
            old.BillingMethod_CAT,
            old.BillingMethod_CD,
            old.BillsCustomer,
            old.BoardClasses,
            old.BooksLocation,
            old.ChangeBy,
            old.ChargeBackBeginDate,
            old.ChargeBackCode1,
            old.ChargeBackCode2,
            old.ChargeBackCode3,
            old.ChargeBackPct,
            old.Comments_ID,
            old.Company_ID,
            old.CompanyType_CAT,
            old.CompanyType_CD,
            old.CorpStatusDate,
            old.DateGuidelinesReturned,
            old.DirectorsAuthorized,
            old.DirectorsComments_ID,
            old.DirectorsMax,
            old.DirectorsMin,
            old.DirectorsQuorum,
            old.DismissalDate,
            old.Domicile_CAT,
            old.Domicile_CD,
            old.EndDate,
            old.ExternalEntityNumber,
			old.eInvoicingVendorID,
            old.FemaleOwnership,
            old.FiscalYearEnd,
            old.GuidelinesReturned,
            old.HasEmployees,
            old.InternalNumber,
            old.IsBillingEntity,
            old.IsInsuranceCompany,
            old.LastChange,
            old.LastMeetingDate,
			old.LHorganizationID,
            old.LineOfBusiness_CAT,
            old.LineOfBusiness_CD,
            old.LLCGovernedBy,
            old.MinorityFirm,
            old.PaymentMethod_CAT,
            old.PaymentMethod_CD,
            old.Purpose_ID,
            old.Region_CAT,
            old.Region_CD,
            old.Reject,
            old.SealLocation,
            old.SubType_CAT,
            old.SubType_CD,
            old.Successor_EID,
            old.TaxYearEnd,
            old.TerminationDate,
            new.AccountCode,
            new.AdministrationNumber,
            new.AgreementDate,
            new.AlternateName,
            new.AnnualMeetingDate,
            new.AnnualMeetingMonth,
            new.AnnualMeetingNotes_ID,
            new.ApprovedDate,
            new.ApprovedFirm,
            new.BeginDate,
            new.BillingMethod_CAT,
            new.BillingMethod_CD,
            new.BillsCustomer,
            new.BoardClasses,
            new.BooksLocation,
            new.ChangeBy,
            new.ChargeBackBeginDate,
            new.ChargeBackCode1,
            new.ChargeBackCode2,
            new.ChargeBackCode3,
            new.ChargeBackPct,
            new.Comments_ID,
            new.Company_ID,
            new.CompanyType_CAT,
            new.CompanyType_CD,
            new.CorpStatusDate,
            new.DateGuidelinesReturned,
            new.DirectorsAuthorized,
            new.DirectorsComments_ID,
            new.DirectorsMax,
            new.DirectorsMin,
            new.DirectorsQuorum,
            new.DismissalDate,
            new.Domicile_CAT,
            new.Domicile_CD,
            new.EndDate,
            new.ExternalEntityNumber,
			new.eInvoicingVendorID,
            new.FemaleOwnership,
            new.FiscalYearEnd,
            new.GuidelinesReturned,
            new.HasEmployees,
            new.InternalNumber,
            new.IsBillingEntity,
            new.IsInsuranceCompany,
            new.LastChange,
            new.LastMeetingDate,
			new.LHorganizationID,
            new.LineOfBusiness_CAT,
            new.LineOfBusiness_CD,
            new.LLCGovernedBy,
            new.MinorityFirm,
            new.PaymentMethod_CAT,
            new.PaymentMethod_CD,
            new.Purpose_ID,
            new.Region_CAT,
            new.Region_CD,
            new.Reject,
            new.SealLocation,
            new.SubType_CAT,
            new.SubType_CD,
            new.Successor_EID,
            new.TaxYearEnd,
            new.TerminationDate,
            @@IDENTITY, ''U'', @TransactionUser, @TransactionDate
          from deleted old, inserted new
          where old.Company_ID = new.Company_ID
        end
        else if exists (select * from inserted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''I'', @TransactionUser, @TransactionDate, ''COMPANY'') 
          insert Company_Audit
            (
             new_AccountCode,
             new_AdministrationNumber,
             new_AgreementDate,
             new_AlternateName,
             new_AnnualMeetingDate,
             new_AnnualMeetingMonth,
             new_AnnualMeetingNotes_ID,
             new_ApprovedDate,
             new_ApprovedFirm,
             new_BeginDate,
             new_BillingMethod_CAT,
             new_BillingMethod_CD,
             new_BillsCustomer,
             new_BoardClasses,
             new_BooksLocation,
             new_ChangeBy,
             new_ChargeBackBeginDate,
             new_ChargeBackCode1,
             new_ChargeBackCode2,
             new_ChargeBackCode3,
             new_ChargeBackPct,
             new_Comments_ID,
             new_Company_ID,
             new_CompanyType_CAT,
             new_CompanyType_CD,
             new_CorpStatusDate,
             new_DateGuidelinesReturned,
             new_DirectorsAuthorized,
             new_DirectorsComments_ID,
             new_DirectorsMax,
             new_DirectorsMin,
             new_DirectorsQuorum,
             new_DismissalDate,
             new_Domicile_CAT,
             new_Domicile_CD,
             new_EndDate,
             new_ExternalEntityNumber,
			 new_eInvoicingVendorID,
             new_FemaleOwnership,
             new_FiscalYearEnd,
             new_GuidelinesReturned,
             new_HasEmployees,
             new_InternalNumber,
             new_IsBillingEntity,
             new_IsInsuranceCompany,
             new_LastChange,
             new_LastMeetingDate,
			 new_LHorganizationID,
             new_LineOfBusiness_CAT,
             new_LineOfBusiness_CD,
             new_LLCGovernedBy,
             new_MinorityFirm,
             new_PaymentMethod_CAT,
             new_PaymentMethod_CD,
             new_Purpose_ID,
             new_Region_CAT,
             new_Region_CD,
             new_Reject,
             new_SealLocation,
             new_SubType_CAT,
             new_SubType_CD,
             new_Successor_EID,
             new_TaxYearEnd,
             new_TerminationDate,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            AccountCode,
            AdministrationNumber,
            AgreementDate,
            AlternateName,
            AnnualMeetingDate,
            AnnualMeetingMonth,
            AnnualMeetingNotes_ID,
            ApprovedDate,
            ApprovedFirm,
            BeginDate,
            BillingMethod_CAT,
            BillingMethod_CD,
            BillsCustomer,
            BoardClasses,
            BooksLocation,
            ChangeBy,
            ChargeBackBeginDate,
            ChargeBackCode1,
            ChargeBackCode2,
            ChargeBackCode3,
            ChargeBackPct,
            Comments_ID,
            Company_ID,
            CompanyType_CAT,
            CompanyType_CD,
            CorpStatusDate,
            DateGuidelinesReturned,
            DirectorsAuthorized,
            DirectorsComments_ID,
            DirectorsMax,
            DirectorsMin,
            DirectorsQuorum,
            DismissalDate,
            Domicile_CAT,
            Domicile_CD,
            EndDate,
            ExternalEntityNumber,
			eInvoicingVendorID,
            FemaleOwnership,
            FiscalYearEnd,
            GuidelinesReturned,
            HasEmployees,
            InternalNumber,
            IsBillingEntity,
            IsInsuranceCompany,
            LastChange,
            LastMeetingDate,
			LHorganizationID,
            LineOfBusiness_CAT,
            LineOfBusiness_CD,
            LLCGovernedBy,
            MinorityFirm,
            PaymentMethod_CAT,
            PaymentMethod_CD,
            Purpose_ID,
            Region_CAT,
            Region_CD,
            Reject,
            SealLocation,
            SubType_CAT,
            SubType_CD,
            Successor_EID,
            TaxYearEnd,
            TerminationDate,
            @@IDENTITY, ''I'', @TransactionUser, @TransactionDate
          from inserted
        end
        else
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''D'', @TransactionUser, @TransactionDate, ''COMPANY'') 
          insert Company_Audit
            (  
             old_AccountCode,
             old_AdministrationNumber,
             old_AgreementDate,
             old_AlternateName,
             old_AnnualMeetingDate,
             old_AnnualMeetingMonth,
             old_AnnualMeetingNotes_ID,
             old_ApprovedDate,
             old_ApprovedFirm,
             old_BeginDate,
             old_BillingMethod_CAT,
             old_BillingMethod_CD,
             old_BillsCustomer,
             old_BoardClasses,
             old_BooksLocation,
             old_ChangeBy,
             old_ChargeBackBeginDate,
             old_ChargeBackCode1,
             old_ChargeBackCode2,
             old_ChargeBackCode3,
             old_ChargeBackPct,
             old_Comments_ID,
             old_Company_ID,
             old_CompanyType_CAT,
             old_CompanyType_CD,
             old_CorpStatusDate,
             old_DateGuidelinesReturned,
             old_DirectorsAuthorized,
             old_DirectorsComments_ID,
             old_DirectorsMax,
             old_DirectorsMin,
             old_DirectorsQuorum,
             old_DismissalDate,
             old_Domicile_CAT,
             old_Domicile_CD,
             old_EndDate,
             old_ExternalEntityNumber,
			 old_eInvoicingVendorID,
             old_FemaleOwnership,
             old_FiscalYearEnd,
             old_GuidelinesReturned,
             old_HasEmployees,
             old_InternalNumber,
             old_IsBillingEntity,
             old_IsInsuranceCompany,
             old_LastChange,
             old_LastMeetingDate,
			 old_LHorganizationID,
             old_LineOfBusiness_CAT,
             old_LineOfBusiness_CD,
             old_LLCGovernedBy,
             old_MinorityFirm,
             old_PaymentMethod_CAT,
             old_PaymentMethod_CD,
             old_Purpose_ID,
             old_Region_CAT,
             old_Region_CD,
             old_Reject,
             old_SealLocation,
             old_SubType_CAT,
             old_SubType_CD,
             old_Successor_EID,
             old_TaxYearEnd,
             old_TerminationDate,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            AccountCode,
            AdministrationNumber,
            AgreementDate,
            AlternateName,
            AnnualMeetingDate,
            AnnualMeetingMonth,
            AnnualMeetingNotes_ID,
            ApprovedDate,
            ApprovedFirm,
            BeginDate,
            BillingMethod_CAT,
            BillingMethod_CD,
            BillsCustomer,
            BoardClasses,
            BooksLocation,
            ChangeBy,
            ChargeBackBeginDate,
            ChargeBackCode1,
            ChargeBackCode2,
            ChargeBackCode3,
            ChargeBackPct,
            Comments_ID,
            Company_ID,
            CompanyType_CAT,
            CompanyType_CD,
            CorpStatusDate,
            DateGuidelinesReturned,
            DirectorsAuthorized,
            DirectorsComments_ID,
            DirectorsMax,
            DirectorsMin,
            DirectorsQuorum,
            DismissalDate,
            Domicile_CAT,
            Domicile_CD,
            EndDate,
            ExternalEntityNumber,
			eInvoicingVendorID,
            FemaleOwnership,
            FiscalYearEnd,
            GuidelinesReturned,
            HasEmployees,
            InternalNumber,
            IsBillingEntity,
            IsInsuranceCompany,
            LastChange,
            LastMeetingDate,
			LHorganizationID,
            LineOfBusiness_CAT,
            LineOfBusiness_CD,
            LLCGovernedBy,
            MinorityFirm,
            PaymentMethod_CAT,
            PaymentMethod_CD,
            Purpose_ID,
            Region_CAT,
            Region_CD,
            Reject,
            SealLocation,
            SubType_CAT,
            SubType_CD,
            Successor_EID,
            TaxYearEnd,
            TerminationDate,
            @@IDENTITY, ''D'', @TransactionUser, @TransactionDate
          from deleted
        end'
	exec (@strSQLa)
end
else
    print 'The command(s) completed successfully.'
    print ''
go
---Matter
if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Matter') = 'Audit_Matter'
begin
    drop trigger Audit_Matter
    print 'Dropped trigger.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTrigger from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin
declare @strSQLa   varchar(max)

set @strSQLa =	
'
create trigger Audit_Matter on Matter for insert, update, delete
as
declare @UserSID           int,
        @TransactionUser   varchar(20),
        @TransactionDate   datetime

        select  @UserSID = (select @@SPID),
          @TransactionDate = getdate()

        select  @TransactionUser = (select LoginName from AuditUserSID where UserSID = @UserSID and LoginDate > dateadd(mi,-5,getdate()))

        if @TransactionUser is null
           select @TransactionUser = ''Unknown''

        if exists (select * from inserted) and exists (select * from deleted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''U'', @TransactionUser, @TransactionDate, ''MATTER'') 
          insert Matter_Audit
            (
             old_MatterNumber_ID,
             old_Matter_CD,
             old_MatterStatus_CD,
             old_LogicalGroup_ID,
             old_MatterNumber,
             old_MatterName,
             old_FileNumber,
             old_ProductService_CD,
             old_SubProductService_CD,
             old_OpenDate,
             old_OpenDate_ID,
             old_CloseDate,
             old_CloseDate_ID,
             old_ReOpenDate,
             old_ReOpenDate_ID,
             old_Law_CD,
             old_SubLaw_CD,
             old_LongMatterName_ID,
             old_LongMatterName,
             old_Comments_ID,
             old_TargetDate,
             old_TargetDate_ID,
             old_State_CD,
             old_Country_CD,
             old_Region_CD,
             old_Litigated,
             old_LegalSection_CD,
             old_Budgeted,
             old_Insured,
             old_AccrueCosts,
             old_Priority_CD,
             old_PrivateMatter,
             old_PrivateChangeBy_ID,
             old_PrivateChangeDate,
             old_Exported,
             old_BillAfterClose,
			 old_eInvoicingMatterID,
			 old_NeedSync,
			 old_CollaboratiSync,
			 old_LHMatterID,
			 old_ActiveHolds,
             old_CreatedDate,
             old_ChangeBy,
             old_LastChange,
             old_Matter_CAT,
             old_MatterStatus_CAT,
             old_ProductService_CAT,
             old_SubProductService_CAT,
             old_Law_CAT,
             old_SubLaw_CAT,
             old_State_CAT,
             old_Country_CAT,
             old_Region_CAT,
             old_LegalSection_CAT,
             old_Priority_CAT,
             new_MatterNumber_ID,
             new_Matter_CD,
             new_MatterStatus_CD,
             new_LogicalGroup_ID,
             new_MatterNumber,
             new_MatterName,
             new_FileNumber,
             new_ProductService_CD,
             new_SubProductService_CD,
             new_OpenDate,
             new_OpenDate_ID,
             new_CloseDate,
             new_CloseDate_ID,
             new_ReOpenDate,
             new_ReOpenDate_ID,
             new_Law_CD,
             new_SubLaw_CD,
             new_LongMatterName_ID,
             new_LongMatterName,
             new_Comments_ID,
             new_TargetDate,
             new_TargetDate_ID,
             new_State_CD,
             new_Country_CD,
             new_Region_CD,
             new_Litigated,
             new_LegalSection_CD,
             new_Budgeted,
             new_Insured,
             new_AccrueCosts,
             new_Priority_CD,
             new_PrivateMatter,
             new_PrivateChangeBy_ID,
             new_PrivateChangeDate,
             new_Exported,
             new_BillAfterClose,
			 new_eInvoicingMatterID,
			 new_NeedSync,
			 new_CollaboratiSync,
			 new_LHMatterID,
			 new_ActiveHolds,
             new_CreatedDate,
             new_ChangeBy,
             new_LastChange,
             new_Matter_CAT,
             new_MatterStatus_CAT,
             new_ProductService_CAT,
             new_SubProductService_CAT,
             new_Law_CAT,
             new_SubLaw_CAT,
             new_State_CAT,
             new_Country_CAT,
             new_Region_CAT,
             new_LegalSection_CAT,
             new_Priority_CAT,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            old.MatterNumber_ID,
            old.Matter_CD,
            old.MatterStatus_CD,
            old.LogicalGroup_ID,
            old.MatterNumber,
            old.MatterName,
            old.FileNumber,
            old.ProductService_CD,
            old.SubProductService_CD,
            old.OpenDate,
            old.OpenDate_ID,
            old.CloseDate,
            old.CloseDate_ID,
            old.ReOpenDate,
            old.ReOpenDate_ID,
            old.Law_CD,
            old.SubLaw_CD,
            old.LongMatterName_ID,
            old.LongMatterName,
            old.Comments_ID,
            old.TargetDate,
            old.TargetDate_ID,
            old.State_CD,
            old.Country_CD,
            old.Region_CD,
            old.Litigated,
            old.LegalSection_CD,
            old.Budgeted,
            old.Insured,
            old.AccrueCosts,
            old.Priority_CD,
            old.PrivateMatter,
            old.PrivateChangeBy_ID,
            old.PrivateChangeDate,
            old.Exported,
            old.BillAfterClose,
			old.eInvoicingMatterID,
			old.NeedSync,
			old.CollaboratiSync,
			old.LHMatterID,
			old.ActiveHolds,
            old.CreatedDate,
            old.ChangeBy,
            old.LastChange,
            old.Matter_CAT,
            old.MatterStatus_CAT,
            old.ProductService_CAT,
            old.SubProductService_CAT,
            old.Law_CAT,
            old.SubLaw_CAT,
            old.State_CAT,
            old.Country_CAT,
            old.Region_CAT,
            old.LegalSection_CAT,
            old.Priority_CAT,
            new.MatterNumber_ID,
            new.Matter_CD,
            new.MatterStatus_CD,
            new.LogicalGroup_ID,
            new.MatterNumber,
            new.MatterName,
            new.FileNumber,
            new.ProductService_CD,
            new.SubProductService_CD,
            new.OpenDate,
            new.OpenDate_ID,
            new.CloseDate,
            new.CloseDate_ID,
            new.ReOpenDate,
            new.ReOpenDate_ID,
            new.Law_CD,
            new.SubLaw_CD,
            new.LongMatterName_ID,
            new.LongMatterName,
            new.Comments_ID,
            new.TargetDate,
            new.TargetDate_ID,
            new.State_CD,
            new.Country_CD,
            new.Region_CD,
            new.Litigated,
            new.LegalSection_CD,
            new.Budgeted,
            new.Insured,
            new.AccrueCosts,
            new.Priority_CD,
            new.PrivateMatter,
            new.PrivateChangeBy_ID,
            new.PrivateChangeDate,
            new.Exported,
            new.BillAfterClose,
			new.eInvoicingMatterID,
			new.NeedSync,
			new.CollaboratiSync,
			new.LHMatterID,
			new.ActiveHolds,
            new.CreatedDate,
            new.ChangeBy,
            new.LastChange,
            new.Matter_CAT,
            new.MatterStatus_CAT,
            new.ProductService_CAT,
            new.SubProductService_CAT,
            new.Law_CAT,
            new.SubLaw_CAT,
            new.State_CAT,
            new.Country_CAT,
            new.Region_CAT,
            new.LegalSection_CAT,
            new.Priority_CAT,
            @@IDENTITY, ''U'', @TransactionUser, @TransactionDate
          from deleted old, inserted new
          where old.MatterNumber_ID = new.MatterNumber_ID
        end
        else if exists (select * from inserted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''I'', @TransactionUser, @TransactionDate, ''MATTER'') 
          insert Matter_Audit
            (
             new_MatterNumber_ID,
             new_Matter_CD,
             new_MatterStatus_CD,
             new_LogicalGroup_ID,
             new_MatterNumber,
             new_MatterName,
             new_FileNumber,
             new_ProductService_CD,
             new_SubProductService_CD,
             new_OpenDate,
             new_OpenDate_ID,
             new_CloseDate,
             new_CloseDate_ID,
             new_ReOpenDate,
             new_ReOpenDate_ID,
             new_Law_CD,
             new_SubLaw_CD,
             new_LongMatterName_ID,
             new_LongMatterName,
             new_Comments_ID,
             new_TargetDate,
             new_TargetDate_ID,
             new_State_CD,
             new_Country_CD,
             new_Region_CD,
             new_Litigated,
             new_LegalSection_CD,
             new_Budgeted,
             new_Insured,
             new_AccrueCosts,
             new_Priority_CD,
             new_PrivateMatter,
             new_PrivateChangeBy_ID,
             new_PrivateChangeDate,
             new_Exported,
             new_BillAfterClose,
			 new_eInvoicingMatterID,
			 new_NeedSync,
			 new_CollaboratiSync,
			 new_LHMatterID,
			 new_ActiveHolds,
             new_CreatedDate,
             new_ChangeBy,
             new_LastChange,
             new_Matter_CAT,
             new_MatterStatus_CAT,
             new_ProductService_CAT,
             new_SubProductService_CAT,
             new_Law_CAT,
             new_SubLaw_CAT,
             new_State_CAT,
             new_Country_CAT,
             new_Region_CAT,
             new_LegalSection_CAT,
             new_Priority_CAT,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            MatterNumber_ID,
            Matter_CD,
            MatterStatus_CD,
            LogicalGroup_ID,
            MatterNumber,
            MatterName,
            FileNumber,
            ProductService_CD,
            SubProductService_CD,
            OpenDate,
            OpenDate_ID,
            CloseDate,
            CloseDate_ID,
            ReOpenDate,
            ReOpenDate_ID,
            Law_CD,
            SubLaw_CD,
            LongMatterName_ID,
            LongMatterName,
            Comments_ID,
            TargetDate,
            TargetDate_ID,
            State_CD,
            Country_CD,
            Region_CD,
            Litigated,
            LegalSection_CD,
            Budgeted,
            Insured,
            AccrueCosts,
            Priority_CD,
            PrivateMatter,
            PrivateChangeBy_ID,
            PrivateChangeDate,
            Exported,
            BillAfterClose,
			eInvoicingMatterID,
			NeedSync,
			CollaboratiSync,
			LHMatterID,
			ActiveHolds,
            CreatedDate,
            ChangeBy,
            LastChange,
            Matter_CAT,
            MatterStatus_CAT,
            ProductService_CAT,
            SubProductService_CAT,
            Law_CAT,
            SubLaw_CAT,
            State_CAT,
            Country_CAT,
            Region_CAT,
            LegalSection_CAT,
            Priority_CAT,
            @@IDENTITY, ''I'', @TransactionUser, @TransactionDate
          from inserted
        end
        else
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''D'', @TransactionUser, @TransactionDate, ''MATTER'') 
          insert Matter_Audit
            (  
             old_MatterNumber_ID,
             old_Matter_CD,
             old_MatterStatus_CD,
             old_LogicalGroup_ID,
             old_MatterNumber,
             old_MatterName,
             old_FileNumber,
             old_ProductService_CD,
             old_SubProductService_CD,
             old_OpenDate,
             old_OpenDate_ID,
             old_CloseDate,
             old_CloseDate_ID,
             old_ReOpenDate,
             old_ReOpenDate_ID,
             old_Law_CD,
             old_SubLaw_CD,
             old_LongMatterName_ID,
             old_LongMatterName,
             old_Comments_ID,
             old_TargetDate,
             old_TargetDate_ID,
             old_State_CD,
             old_Country_CD,
             old_Region_CD,
             old_Litigated,
             old_LegalSection_CD,
             old_Budgeted,
             old_Insured,
             old_AccrueCosts,
             old_Priority_CD,
             old_PrivateMatter,
             old_PrivateChangeBy_ID,
             old_PrivateChangeDate,
             old_Exported,
             old_BillAfterClose,
			 old_eInvoicingMatterID,
			 old_NeedSync,
			 old_CollaboratiSync,
			 old_LHMatterID,
			 old_ActiveHolds,
             old_CreatedDate,
             old_ChangeBy,
             old_LastChange,
             old_Matter_CAT,
             old_MatterStatus_CAT,
             old_ProductService_CAT,
             old_SubProductService_CAT,
             old_Law_CAT,
             old_SubLaw_CAT,
             old_State_CAT,
             old_Country_CAT,
             old_Region_CAT,
             old_LegalSection_CAT,
             old_Priority_CAT,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            MatterNumber_ID,
            Matter_CD,
            MatterStatus_CD,
            LogicalGroup_ID,
            MatterNumber,
            MatterName,
            FileNumber,
            ProductService_CD,
            SubProductService_CD,
            OpenDate,
            OpenDate_ID,
            CloseDate,
            CloseDate_ID,
            ReOpenDate,
            ReOpenDate_ID,
            Law_CD,
            SubLaw_CD,
            LongMatterName_ID,
            LongMatterName,
            Comments_ID,
            TargetDate,
            TargetDate_ID,
            State_CD,
            Country_CD,
            Region_CD,
            Litigated,
            LegalSection_CD,
            Budgeted,
            Insured,
            AccrueCosts,
            Priority_CD,
            PrivateMatter,
            PrivateChangeBy_ID,
            PrivateChangeDate,
            Exported,
            BillAfterClose,
			eInvoicingMatterID,
			NeedSync,
			CollaboratiSync,
			LHMatterID,
			ActiveHolds,
            CreatedDate,
            ChangeBy,
            LastChange,
            Matter_CAT,
            MatterStatus_CAT,
            ProductService_CAT,
            SubProductService_CAT,
            Law_CAT,
            SubLaw_CAT,
            State_CAT,
            Country_CAT,
            Region_CAT,
            LegalSection_CAT,
            Priority_CAT,
            @@IDENTITY, ''D'', @TransactionUser, @TransactionDate
          from deleted
        end'
exec (@strSQLa)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

---Person
if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_Person') = 'Audit_Person'
begin
    drop trigger Audit_Person
    print 'Dropped trigger.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTrigger from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin
declare @strSQLa   varchar(max)

set @strSQLa =	
'
create trigger Audit_Person on Person for insert, update, delete
as
declare @UserSID           int,
        @TransactionUser   varchar(20),
        @TransactionDate   datetime

        select  @UserSID = (select @@SPID),
          @TransactionDate = getdate()

        select  @TransactionUser = (select LoginName from AuditUserSID where UserSID = @UserSID and LoginDate > dateadd(mi,-5,getdate()))

        if @TransactionUser is null
           select @TransactionUser = ''Unknown''

        if exists (select * from inserted) and exists (select * from deleted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''U'', @TransactionUser, @TransactionDate, ''PERSON'') 
          insert Person_Audit
            (
             old_AdministrationNumber,
             old_BirthDate,
             old_BirthPlace,
             old_ChangeBy,
             old_CitizenJurisdiction_ID,
             old_Comments_ID,
             old_DailyMaximumHours,
             old_DailyMinumumHours,
             old_DeathDate,
             old_DriversLicense,
             old_DriversLicenseJurisdiction_ID,
             old_Employee,
             old_EmployeeEndDate,
             old_EmployeeStartDate,
             old_EthnicClassification_CAT,
             old_EthnicClassification_CD,
             old_FirstName,
             old_Gender,
             old_LastChange,
             old_LastName,
			 old_LHLegalHoldStaffID,
             old_Middle,
             old_Nickname,
             old_PassportNumber,
             old_Person_ID,
             old_Salutation,
             old_Secretary,
             old_SecurityLevel,
             old_Spouse,
             old_SpouseSSN,
             old_StartOfWeek,
             old_Suffix,
             old_Timekeeper,
             old_AssociatedTimekeeperID,
             old_TimekeeperSync,
			 old_eInvoicingTimekeeperID,
			 old_eInvoicingAuthorized,
			 old_Initials,
             old_TimekeeperComments_ID,
             old_WeeklyMaximumHours,
             old_WeeklyMinimumHours,
             new_AdministrationNumber,
             new_BirthDate,
             new_BirthPlace,
             new_ChangeBy,
             new_CitizenJurisdiction_ID,
             new_Comments_ID,
             new_DailyMaximumHours,
             new_DailyMinumumHours,
             new_DeathDate,
             new_DriversLicense,
             new_DriversLicenseJurisdiction_ID,
             new_Employee,
             new_EmployeeEndDate,
             new_EmployeeStartDate,
             new_EthnicClassification_CAT,
             new_EthnicClassification_CD,
             new_FirstName,
             new_Gender,
             new_LastChange,
             new_LastName,
			 new_LHLegalHoldStaffID,
             new_Middle,
             new_Nickname,
             new_PassportNumber,
             new_Person_ID,
             new_Salutation,
             new_Secretary,
             new_SecurityLevel,
             new_Spouse,
             new_SpouseSSN,
             new_StartOfWeek,
             new_Suffix,
             new_Timekeeper,
             new_AssociatedTimekeeperID,
             new_TimekeeperSync,
			 new_eInvoicingTimekeeperID,
			 new_eInvoicingAuthorized,
			 new_Initials,
             new_TimekeeperComments_ID,
             new_WeeklyMaximumHours,
             new_WeeklyMinimumHours,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            old.AdministrationNumber,
            old.BirthDate,
            old.BirthPlace,
            old.ChangeBy,
            old.CitizenJurisdiction_ID,
            old.Comments_ID,
            old.DailyMaximumHours,
            old.DailyMinumumHours,
            old.DeathDate,
            old.DriversLicense,
            old.DriversLicenseJurisdiction_ID,
            old.Employee,
            old.EmployeeEndDate,
            old.EmployeeStartDate,
            old.EthnicClassification_CAT,
            old.EthnicClassification_CD,
            old.FirstName,
            old.Gender,
            old.LastChange,
            old.LastName,
			old.LHLegalHoldStaffID,
            old.Middle,
            old.Nickname,
            old.PassportNumber,
            old.Person_ID,
            old.Salutation,
            old.Secretary,
            old.SecurityLevel,
            old.Spouse,
            old.SpouseSSN,
            old.StartOfWeek,
            old.Suffix,
            old.Timekeeper,
            old.AssociatedTimekeeperID,
            old.TimekeeperSync,
			old.eInvoicingTimekeeperID,
			old.eInvoicingAuthorized,
			old.Initials,
            old.TimekeeperComments_ID,
            old.WeeklyMaximumHours,
            old.WeeklyMinimumHours,
            new.AdministrationNumber,
            new.BirthDate,
            new.BirthPlace,
            new.ChangeBy,
            new.CitizenJurisdiction_ID,
            new.Comments_ID,
            new.DailyMaximumHours,
            new.DailyMinumumHours,
            new.DeathDate,
            new.DriversLicense,
            new.DriversLicenseJurisdiction_ID,
            new.Employee,
            new.EmployeeEndDate,
            new.EmployeeStartDate,
            new.EthnicClassification_CAT,
            new.EthnicClassification_CD,
            new.FirstName,
            new.Gender,
            new.LastChange,
            new.LastName,
			new.LHLegalHoldStaffID,
            new.Middle,
            new.Nickname,
            new.PassportNumber,
            new.Person_ID,
            new.Salutation,
            new.Secretary,
            new.SecurityLevel,
            new.Spouse,
            new.SpouseSSN,
            new.StartOfWeek,
            new.Suffix,
            new.Timekeeper,
            new.AssociatedTimekeeperID,
            new.TimekeeperSync,
			new.eInvoicingTimekeeperID,
			new.eInvoicingAuthorized,
			new.Initials,
            new.TimekeeperComments_ID,
            new.WeeklyMaximumHours,
            new.WeeklyMinimumHours,
            @@IDENTITY, ''U'', @TransactionUser, @TransactionDate
          from deleted old, inserted new
          where old.Person_ID = new.Person_ID
        end
        else if exists (select * from inserted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''I'', @TransactionUser, @TransactionDate, ''PERSON'') 
          insert Person_Audit
            (
             new_AdministrationNumber,
             new_BirthDate,
             new_BirthPlace,
             new_ChangeBy,
             new_CitizenJurisdiction_ID,
             new_Comments_ID,
             new_DailyMaximumHours,
             new_DailyMinumumHours,
             new_DeathDate,
             new_DriversLicense,
             new_DriversLicenseJurisdiction_ID,
             new_Employee,
             new_EmployeeEndDate,
             new_EmployeeStartDate,
             new_EthnicClassification_CAT,
             new_EthnicClassification_CD,
             new_FirstName,
             new_Gender,
             new_LastChange,
             new_LastName,
			 new_LHLegalHoldStaffID,
             new_Middle,
             new_Nickname,
             new_PassportNumber,
             new_Person_ID,
             new_Salutation,
             new_Secretary,
             new_SecurityLevel,
             new_Spouse,
             new_SpouseSSN,
             new_StartOfWeek,
             new_Suffix,
             new_Timekeeper,
             new_AssociatedTimekeeperID,
             new_TimekeeperSync,
			 new_eInvoicingTimekeeperID,
			 new_eInvoicingAuthorized,
			 new_Initials,
             new_TimekeeperComments_ID,
             new_WeeklyMaximumHours,
             new_WeeklyMinimumHours,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            AdministrationNumber,
            BirthDate,
            BirthPlace,
            ChangeBy,
            CitizenJurisdiction_ID,
            Comments_ID,
            DailyMaximumHours,
            DailyMinumumHours,
            DeathDate,
            DriversLicense,
            DriversLicenseJurisdiction_ID,
            Employee,
            EmployeeEndDate,
            EmployeeStartDate,
            EthnicClassification_CAT,
            EthnicClassification_CD,
            FirstName,
            Gender,
            LastChange,
            LastName,
			LHLegalHoldStaffID,
            Middle,
            Nickname,
            PassportNumber,
            Person_ID,
            Salutation,
            Secretary,
            SecurityLevel,
            Spouse,
            SpouseSSN,
            StartOfWeek,
            Suffix,
            Timekeeper,
            AssociatedTimekeeperID,
            TimekeeperSync,
			eInvoicingTimekeeperID,
			eInvoicingAuthorized,
			Initials,
            TimekeeperComments_ID,
            WeeklyMaximumHours,
            WeeklyMinimumHours,
            @@IDENTITY, ''I'', @TransactionUser, @TransactionDate
          from inserted
        end
        else
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''D'', @TransactionUser, @TransactionDate, ''PERSON'') 
          insert Person_Audit
            (  
             old_AdministrationNumber,
             old_BirthDate,
             old_BirthPlace,
             old_ChangeBy,
             old_CitizenJurisdiction_ID,
             old_Comments_ID,
             old_DailyMaximumHours,
             old_DailyMinumumHours,
             old_DeathDate,
             old_DriversLicense,
             old_DriversLicenseJurisdiction_ID,
             old_Employee,
             old_EmployeeEndDate,
             old_EmployeeStartDate,
             old_EthnicClassification_CAT,
             old_EthnicClassification_CD,
             old_FirstName,
             old_Gender,
             old_LastChange,
			 old_LHLegalHoldStaffID,
             old_LastName,
             old_Middle,
             old_Nickname,
             old_PassportNumber,
             old_Person_ID,
             old_Salutation,
             old_Secretary,
             old_SecurityLevel,
             old_Spouse,
             old_SpouseSSN,
             old_StartOfWeek,
             old_Suffix,
             old_Timekeeper,
             old_AssociatedTimekeeperID,
             old_TimekeeperSync,
			 old_eInvoicingTimekeeperID,
			 old_eInvoicingAuthorized,
			 old_Initials,
             old_TimekeeperComments_ID,
             old_WeeklyMaximumHours,
             old_WeeklyMinimumHours,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            AdministrationNumber,
            BirthDate,
            BirthPlace,
            ChangeBy,
            CitizenJurisdiction_ID,
            Comments_ID,
            DailyMaximumHours,
            DailyMinumumHours,
            DeathDate,
            DriversLicense,
            DriversLicenseJurisdiction_ID,
            Employee,
            EmployeeEndDate,
            EmployeeStartDate,
            EthnicClassification_CAT,
            EthnicClassification_CD,
            FirstName,
            Gender,
            LastChange,
            LastName,
			LHLegalHoldStaffID,
            Middle,
            Nickname,
            PassportNumber,
            Person_ID,
            Salutation,
            Secretary,
            SecurityLevel,
            Spouse,
            SpouseSSN,
            StartOfWeek,
            Suffix,
            Timekeeper,
            AssociatedTimekeeperID,
            TimekeeperSync,
			eInvoicingTimekeeperID,
			eInvoicingAuthorized,
			Initials,
            TimekeeperComments_ID,
            WeeklyMaximumHours,
            WeeklyMinimumHours,
            @@IDENTITY, ''D'', @TransactionUser, @TransactionDate
          from deleted
        end'
exec (@strSQLa)
end
else
    print 'The command(s) completed successfully.'
    print ''
go


-- Begin grant permissions (audit tables)
if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Company') = 'T'
begin
    grant select on Company_Audit to <LOGIN>
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Matter') = 'T'
begin
    grant select on Matter_Audit to <LOGIN>
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Person') = 'T'
begin
    grant select on Person_Audit to <LOGIN>
end
else
    print 'The command(s) completed successfully.'
    print ''
go
-- End grant permissions (audit tables)


---------------- End Auditing Section ----------------


-----------------BEGIN new  table----------------------------------

--LH_LegalholdMatter
IF OBJECT_ID('LH_LegalHoldMatter', 'U') IS NOT NULL
DROP TABLE LH_LegalHoldMatter;
go 

create table LH_LegalHoldMatter (
LH_LegalHoldMatter_ID	 int	 		not null,
MatterNumber_ID			 int			null,
LHHoldKey				 varchar(50) 	null,
CreatedDate				 datetime		null,
CreatedBy				 varchar(20)	null,
LastChange				 datetime		null,
ChangeBy				 varchar(20) 	null,
constraint PK_LH_LEGALHOLDMATTER primary key (LH_LegalHoldMatter_ID)
)
go

create index IDX_LHM_MATTERNUMBER_ID on LH_LegalHoldMatter (
MatterNumber_ID asc
)
go

alter table LH_LegalHoldMatter
	add constraint FK_LH_LEGAL_REF_3143_MATTER foreign key (MatterNumber_ID)
		references Matter (MatterNumber_ID)
go


--auditing for the new table
IF OBJECT_ID('LH_LegalHoldMatter_Audit', 'U') IS NOT NULL
DROP TABLE LH_LegalHoldMatter_Audit;

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
create table LH_LegalHoldMatter_Audit
(
	old_LH_LegalHoldMatter_ID	 int	 		null,
	new_LH_LegalHoldMatter_ID	 int	 		null,
	old_MatterNumber_ID			 int			null,
	new_MatterNumber_ID			 int			null,
	old_LHHoldKey				 varchar(50) 	null,
	new_LHHoldKey				 varchar(50) 	null,
	old_CreatedDate				 datetime		null,
	new_CreatedDate				 datetime		null,
	old_CreatedBy				 varchar(20)	null,
	new_CreatedBy				 varchar(20)	null,
	old_LastChange				 datetime		null,
	new_LastChange				 datetime		null,
	old_ChangeBy				 varchar(20) 	null,
	new_ChangeBy				 varchar(20) 	null,
	Transaction_ID               numeric(27,0)  null,
    TransactionType              char(1)        null,
    TransactionUser              varchar(20)    null,
    TransactionDate              datetime       null	
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_LH_LegalHoldMatter') = 'Audit_LH_LegalHoldMatter'
begin
    drop trigger Audit_LH_LegalHoldMatter
    print 'The command(s) completed successfully.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTrigger from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
declare @strSQLa   varchar(max)

set @strSQLa =	
'
create trigger Audit_LH_LegalHoldMatter on LH_LegalHoldMatter for insert, update, delete
as
declare @UserSID           int,
        @TransactionUser   varchar(20),
        @TransactionDate   datetime

        select  @UserSID = (select @@SPID),
          @TransactionDate = getdate()

        select  @TransactionUser = (select LoginName from AuditUserSID where UserSID = @UserSID and LoginDate > dateadd(mi,-5,getdate()))

        if @TransactionUser is null
           select @TransactionUser = ''Unknown''

        if exists (select * from inserted) and exists (select * from deleted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''U'', @TransactionUser, @TransactionDate, ''LH_LEGALHOLDMATTER'') 
			insert LH_LegalHoldMatter_Audit
            (
			 old_ChangeBy,
			 old_CreatedBy,
			 old_CreatedDate,
			 old_LastChange,
			 old_LHHoldKey,
			 old_LH_LegalHoldMatter_ID,
			 old_MatterNumber_ID,
             new_ChangeBy,
             new_CreatedBy,
             new_CreatedDate,
             new_LastChange,
             new_LHHoldKey,
             new_LH_LegalHoldMatter_ID,
             new_MatterNumber_ID,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
			select 
			 old.ChangeBy,
			 old.CreatedBy,
			 old.CreatedDate,
			 old.LastChange,
			 old.LHHoldKey,
			 old.LH_LegalHoldMatter_ID,
			 old.MatterNumber_ID,
			 new.ChangeBy,
			 new.CreatedBy,
			 new.CreatedDate,
			 new.LastChange,
			 new.LHHoldKey,
			 new.LH_LegalHoldMatter_ID,
			 new.MatterNumber_ID,
			 @@IDENTITY, ''U'', @TransactionUser, @TransactionDate
          from deleted old, inserted new
          where old.LH_LegalHoldMatter_ID = new.LH_LegalHoldMatter_ID
		end
		else if exists (select * from inserted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''I'', @TransactionUser, @TransactionDate, ''LH_LEGALHOLDMATTER'') 
		  insert LH_LegalHoldMatter_Audit
			(
			 new_ChangeBy,
             new_CreatedBy,
             new_CreatedDate,
             new_LastChange,
             new_LHHoldKey,
             new_LH_LegalHoldMatter_ID,
             new_MatterNumber_ID,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
		  select
            ChangeBy,
            CreatedBy,
            CreatedDate,
            LastChange,
            LHHoldKey,
            LH_LegalHoldMatter_ID,
            MatterNumber_ID,
            @@IDENTITY, ''I'', @TransactionUser, @TransactionDate
          from inserted
        end
		else
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''D'', @TransactionUser, @TransactionDate, ''LH_LEGALHOLDMATTER'') 
          insert LH_LegalHoldMatter_Audit
            (  
             old_ChangeBy,
             old_CreatedBy,
             old_CreatedDate,
             old_LastChange,
             old_LHHoldKey,
             old_LH_LegalHoldMatter_ID,
             old_MatterNumber_ID,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
            ChangeBy,
            CreatedBy,
            CreatedDate,
            LastChange,
            LHHoldKey,
            LH_LegalHoldMatter_ID,
            MatterNumber_ID,
            @@IDENTITY, ''D'', @TransactionUser, @TransactionDate
          from deleted
        end'
exec (@strSQLa)
end
else
    print 'The command(s) completed successfully.'
    print ''
go



if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
    grant select on LH_LegalHoldMatter_Audit to <LOGIN>
end
else
    print 'The command(s) completed successfully.'
    print ''
go

--Adding new table LH_MatterStaffAssignee

--LH_MatterStaffAssignee
IF OBJECT_ID('LH_MatterStaffAssignee', 'U') IS NOT NULL
DROP TABLE LH_MatterStaffAssignee;
go 

create table LH_MatterStaffAssignee  (
LH_MatterStaffAssignee_ID int          not null,
MatterPlayer_ID 		  int 		   null,
LH_MatterStaff_ID         varchar(50)  null,
LH_Hold_ID			      varchar(50)  null,
CreatedDate               datetime     null,
LastChange                datetime	   null,
ChangeBy           		  varchar(50)  null,
   constraint PK_LH_MATTERSTAFFASSIGNEE primary key ("LH_MatterStaffAssignee_ID")
)
go

create index IDX_LHM_MATTERPLAYER_ID on LH_MatterStaffAssignee (
MatterPlayer_ID asc
)
go

alter table LH_MatterStaffAssignee
   add constraint FK_LH_MATTE_REF_3144_MATTERPL foreign key (MatterPlayer_ID)
      references MatterPlayer (MatterPlayer_ID)
go

--auditing for the new table
IF OBJECT_ID('LH_MatterStaffAssignee_Audit', 'U') IS NOT NULL
DROP TABLE LH_MatterStaffAssignee_Audit;

if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
create table LH_MatterStaffAssignee_Audit (
old_LH_MatterStaffAssignee_ID int          null,
new_LH_MatterStaffAssignee_ID int          null,
old_MatterPlayer_ID 		  int 		   null,
new_MatterPlayer_ID 		  int 		   null,
old_LH_MatterStaff_ID         varchar(50)  null,
new_LH_MatterStaff_ID         varchar(50)  null,
old_LH_Hold_ID			      varchar(50)  null,
new_LH_Hold_ID			      varchar(50)  null,
old_CreatedDate               datetime     null,
new_CreatedDate               datetime     null,
old_LastChange                datetime	   null,
new_LastChange                datetime	   null,
old_ChangeBy           		  varchar(50)  null,
new_ChangeBy           		  varchar(50)  null,
Transaction_ID            	  numeric(27,0) null,
TransactionType           	  char(1)      null,
TransactionUser           	  varchar(20)  null,
TransactionDate           	  datetime      
)
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select name from sysobjects
    where xtype = 'TR'
    and name = 'Audit_LH_MatterStaffAssignee') = 'Audit_LH_MatterStaffAssignee'
begin
    drop trigger Audit_LH_MatterStaffAssignee
    print 'The command(s) completed successfully.'
    print ''
end
else
    print 'The command(s) completed successfully.'
    print ''
go

if (select UpgradeTrigger from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
declare @strSQLa   varchar(max)

set @strSQLa =	
'
create trigger Audit_LH_MatterStaffAssignee on LH_MatterStaffAssignee for insert, update, delete
as
declare @UserSID           int,
        @TransactionUser   varchar(20),
        @TransactionDate   datetime

        select  @UserSID = (select @@SPID),
          @TransactionDate = getdate()

        select  @TransactionUser = (select LoginName from AuditUserSID where UserSID = @UserSID and LoginDate > dateadd(mi,-5,getdate()))

        if @TransactionUser is null
           select @TransactionUser = ''Unknown''
		   
		if exists (select * from inserted) and exists (select * from deleted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''U'', @TransactionUser, @TransactionDate, ''LH_MATTERSTAFFASSIGNEE'') 
          insert LH_MatterStaffAssignee_Audit
            (
             old_ChangeBy,
             old_CreatedDate,
			 old_LH_Hold_ID,
             old_LH_MatterStaffAssignee_ID,             
             old_LH_MatterStaff_ID,
			 old_MatterPlayer_ID,
             old_LastChange,
             new_ChangeBy,
             new_CreatedDate,
			 new_LH_Hold_ID,
             new_LH_MatterStaffAssignee_ID,             
             new_LH_MatterStaff_ID,
			 new_MatterPlayer_ID,
             new_LastChange,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
			 old.ChangeBy,
             old.CreatedDate,
			 old.LH_Hold_ID,
             old.LH_MatterStaffAssignee_ID,             
             old.LH_MatterStaff_ID,
			 old.MatterPlayer_ID,
             old.LastChange,
             new.ChangeBy,
             new.CreatedDate,
			 new.LH_Hold_ID,
             new.LH_MatterStaffAssignee_ID,             
             new.LH_MatterStaff_ID,
			 new.MatterPlayer_ID,
             new.LastChange,
            @@IDENTITY, ''U'', @TransactionUser, @TransactionDate
          from deleted old, inserted new
          where old.LH_MatterStaffAssignee_ID = new.LH_MatterStaffAssignee_ID
     	end
		else if exists (select * from inserted)
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''I'', @TransactionUser, @TransactionDate, ''LH_MATTERSTAFFASSIGNEE'') 
		  insert LH_MatterStaffAssignee_Audit
			(
			 new_ChangeBy,
             new_CreatedDate,
			 new_LH_Hold_ID,
             new_LH_MatterStaffAssignee_ID,             
             new_LH_MatterStaff_ID,
			 new_MatterPlayer_ID,
             new_LastChange,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
		  select
			ChangeBy,
            CreatedDate,
			LH_Hold_ID,
            LH_MatterStaffAssignee_ID,             
            LH_MatterStaff_ID,
			MatterPlayer_ID,
            LastChange,
            @@IDENTITY, ''I'', @TransactionUser, @TransactionDate
          from inserted
        end
		else
        begin
          insert into AuditTransaction
            (TransactionType, TransactionUser, TransactionDate, TableName)
          values
            (''D'', @TransactionUser, @TransactionDate, ''LH_MATTERSTAFFASSIGNEE'') 
          insert LH_MatterStaffAssignee_Audit
            (  
             old_ChangeBy,
             old_CreatedDate,
			 old_LH_Hold_ID,
             old_LH_MatterStaffAssignee_ID,             
             old_LH_MatterStaff_ID,
			 old_MatterPlayer_ID,
             old_LastChange,
             Transaction_ID, TransactionType, TransactionUser, TransactionDate)
          select
			 ChangeBy,
             CreatedDate,
			 LH_Hold_ID,
             LH_MatterStaffAssignee_ID,             
             LH_MatterStaff_ID,
			 MatterPlayer_ID,
             LastChange,
            @@IDENTITY, ''D'', @TransactionUser, @TransactionDate
          from deleted
        end'
exec (@strSQLa)
end
else
    print 'The command(s) completed successfully.'
    print ''
go



if (select UpgradeTable from tmp_AuditingUpgrade
    where TableName = 'Invoice') = 'T'
begin
    grant select on LH_MatterStaffAssignee_Audit to <LOGIN>
end
else
    print 'The command(s) completed successfully.'
    print ''
go
----End Table Creation 
-- Begin drop tmp_AuditingUpgrade table

drop table tmp_AuditingUpgrade
go

-- End drop tmp_AuditingUpgrade table

-----------------Begin Function  Section---------------------------

--BEGIN create function MLHGetPlayerInfo
IF EXISTS (SELECT * FROM sys.objects WHERE object_id = OBJECT_ID(N'MLHGetPlayerInfo')
	AND type in (N'FN', N'IF',N'TF', N'FS', N'FT'))
	drop function MLHGetPlayerInfo;
	go
	
 create FUNCTION MLHGetPlayerInfo
    (

    	@matterId as int
    )
    RETURNS TABLE 
    AS
    RETURN 
    (
   	Select p.Person_ID,  p.FirstName, p.LastName, p.Suffix, 

		 p.LHlegalholdStaffID as matterStaffID,
		 
		 e.Status_CD as personStatus, 

		 mp.Role_CD, lcs.SyncValue as playerRoleUID,

		 mp.MatterPlayer_ID,		 

		 mp.StartDate,mp.EndDate,m.LHMatterID

	from Person as p
	
	inner join Entity as e on e.Entity_EID = p.Person_ID	

	inner join MatterPlayer as mp on p.Person_ID = mp.Entity_EID

	inner join Matter as m on m.MatterNumber_ID = mp.MatterNumber_ID

	inner join LookupCode as lc on lc.CodeName = mp.Role_CD

	inner join LookupCodeSync as lcs on lcs.LookupCode_ID = lc.LookupCode_ID

	where mp.MatterNumber_ID = @matterId 
    )
go
--END create function MLHGetPlayerInfo

-----------------End Function  Section-------------------------------

-----------------Begin View Section-------------------------------
-- Begin Legalhold views

if exists
  (select name from sysobjects
   where name = 'VLH_MatterTypes_Status'
   and type = 'V')
  drop view VLH_MatterTypes_Status
go

create view VLH_MatterTypes_Status
as
/************************************************************************************************************************
Definition: This view returns the matterplayers status that have been syncing to Legalhold
************************************************************************************************************************/
    select lc.LookupCode_ID, lc.CodeName, lcs.Status

    from LookupCode lc

    left join LookupCodeSync lcs

    on lcs.LookupCode_ID = lc.LookupCode_ID

    where lc.LookupCodeCategory_ID = 38

GO

if exists
  (select name from sysobjects
   where name = 'VLH_RolesCodes_Status'
   and type = 'V')
  drop view VLH_RolesCodes_Status
go

create view VLH_RolesCodes_Status
as
/************************************************************************************************************************
Definition: This view returns the RoleCodes status that have been syncing to Legalhold
************************************************************************************************************************/
  select lc.LookupCode_ID, lc.CodeName, lc2.CodeName as PlayerType, lcs.Status
	 from LookupCode lc 
	 left join LookupCodeSync lcs
	 on lcs.LookupCode_ID=lc.LookupCode_ID 
	 left join LookupCodeSubCategory lcscat
	 on lcscat.SubCode_ID = lc.LookupCode_ID
	 left join LookupCode lc2 
	 on lc2.LookupCode_ID=lcscat.ParentCode_ID 
	 where lc.LookupCodeCategory_ID = 60
GO

-- End Legalhold views

-----------------END View Section-------------------------------

---------------- Begin Data Changes Section ----------------

--initialization
insert into CurrentID values ('LH_LegalHoldMatter', 10000)
go
insert into CurrentID values ('LH_MatterStaffAssignee', 10000)
go

--Adding new category for legalhold
BEGIN 
	DECLARE @lookupCodeCatID int, @LookupCodeID int, @lookupCodeCatIDCurr int, @LookupCodeIDCurr int
	IF NOT EXISTS( select 1 from LookupCodeCategory where CategoryName = 'People Status')
	BEGIN
		SET @lookupCodeCatID = (SELECT MAX(LookupCodeCategory_ID) FROM LookupCodeCategory WHERE LookupCodeCategory_ID < 10000)
		IF @lookupCodeCatID < 9999
		BEGIN
			INSERT INTO LookupCodeCategory VALUES (@lookupCodeCatID + 1, 'People Status', NULL, 'T', 'SYSTEM', NULL)
			SET @LookupCodeID = (SELECT MAX(LookupCode_ID) FROM LookupCode WHERE LookupCode_ID < 10000)
			IF @LookupCodeID < 9999
			BEGIN
				INSERT INTO LookupCode VALUES (@LookupCodeID + 1, @lookupCodeCatID + 1, 'Active', 'F', 'F', 'SYSTEM', NULL)
				INSERT INTO LookupCode VALUES (@LookupCodeID + 2, @lookupCodeCatID + 1, 'Inactive', 'F', 'F', 'SYSTEM', NULL)				
			END
			ELSE
			BEGIN
				SET @LookupCodeID = (SELECT Next_ID FROM CurrentID WHERE TableName = 'LookupCode');
				INSERT INTO LookupCode VALUES (@LookupCodeID + 1, @lookupCodeCatID + 1, 'Active', 'F', 'F', 'SYSTEM', NULL)
				INSERT INTO LookupCode VALUES (@LookupCodeID + 2, @lookupCodeCatID + 1, 'Inactive', 'F', 'F', 'SYSTEM', NULL)
				UPDATE CurrentID SET Next_ID = @LookupCodeID + 2 WHERE TableName = 'LookupCode'				
			END
		END
		ELSE
		BEGIN
			SET @lookupCodeCatID = (SELECT Next_ID FROM CurrentID WHERE TableName = 'LookupCodeCategory');
			INSERT INTO LookupCodeCategory VALUES (@lookupCodeCatID + 1, 'People Status', NULL, 'T', 'SYSTEM', NULL)
			UPDATE CurrentID SET Next_ID = @lookupCodeCatID + 1 WHERE TableName = 'LookupCodeCategory'
			SET @LookupCodeID = (SELECT MAX(LookupCode_ID) FROM LookupCode WHERE LookupCode_ID < 10000)
			IF @LookupCodeID < 9999
			BEGIN
				INSERT INTO LookupCode VALUES (@LookupCodeID + 1, @lookupCodeCatID + 1, 'Active', 'F', 'F', 'SYSTEM', NULL)
				INSERT INTO LookupCode VALUES (@LookupCodeID + 2, @lookupCodeCatID + 1, 'Inactive', 'F', 'F', 'SYSTEM', NULL)				
			END
			ELSE
			BEGIN
			SET @LookupCodeID = (SELECT Next_ID FROM CurrentID WHERE TableName = 'LookupCode');
				INSERT INTO LookupCode VALUES (@LookupCodeID + 1, @lookupCodeCatID + 1, 'Active', 'F', 'F', 'SYSTEM', NULL)
				INSERT INTO LookupCode VALUES (@LookupCodeID + 2, @lookupCodeCatID + 1, 'Inactive', 'F', 'F', 'SYSTEM', NULL)
				UPDATE CurrentID SET Next_ID = @LookupCodeID + 2 WHERE TableName = 'LookupCode'	
			END		
		END
	END
END
go

---------------- End Data Changes Section ----------------

-- Begin grant permissions

-- Tables
grant select, insert, update, delete on LH_LegalHoldMatter to <LOGIN>
go
grant select, insert, update, delete on LH_MatterStaffAssignee to <LOGIN>
go
grant select, insert, update, delete on Company to <LOGIN>
go
grant select, insert, update, delete on Matter to <LOGIN>
go
grant select, insert, update, delete on Person to <LOGIN>
go
grant select on VLH_MatterTypes_Status to <LOGIN>
go
grant select on VLH_RolesCodes_Status to <LOGIN>
go
grant select on MLHGetPlayerInfo to <LOGIN>
go
-- End grant permissions

-- Update DatabaseHistory

insert into DatabaseHistory values
(
  '8.11.0.27.00',
  '08-FEB-2019',
  'Suite81101800-81102700-SQL.sql',
  'Upgrades the database from 8.11.0.18.00 to 8.11.0.27.00.',
  GETDATE()
)
go